'+--------------------------------------------------------------------------+
'|                                OfTheBay                                  |
'|                                                                          |
'|                          GDImage AERO DockBar                            |
'|                     Inspired by the MAC OS X Dockbar                     |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-10-2008 (MM-DD-YYYY)            |
'|                        Last revised : 01-14-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "OfTheBay.exe"

#INCLUDE "Win32API.inc"
#INCLUDE "GDImage.inc"
#RESOURCE "OfTheBay.pbr"

#INCLUDE "OfTheBay.inc"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

'------------------------------------------------------------------------------------------
' LOCAL section
'-----------------------------------------------------------------------------------------
%SCALE_MAX     = 105
%SCALE_DEFAULT = 80
%SCALE_STEP    = 2
%FRAME_SizeX   = 1000
%FRAME_SizeY   = 90 '// Never smaller than 90
%TIMER_Speed   = 0
%SMOOTH_STEP   = 1

$VERSION       = "Of The Bay 2.00"
$USEFONT       = "Trebuchet MS"
%FONTSIZE      = 14
%ID_LEFT       = -1
%ID_RIGHT      = -2
%ID_FLARE      = -3
%ID_BLUEFLARE  = -4
%ID_FOCUS      = -5
%LBOUND        = %ID_FOCUS

%IDM_About     = 101
%IDM_IconFrame = 103
%IDM_IconBack  = 104
%IDM_ShortCut  = 105
%IDM_Sound     = 106
%IDM_Wallpaper = 107
%IDM_BuildOTB  = 109
%IDM_Edit      = 110
%IDM_Restart   = 111
%IDM_Close     = 113

TYPE gSpriteArrayStruct
    x         AS LONG
    y         AS LONG
    w         AS LONG
    h         AS LONG
    scale     AS LONG
    opacity   AS BYTE
    ShellTo   AS ASCIIZ * 260
    IconPath  AS ASCIIZ * 260
    WorkDir   AS ASCIIZ * 260
    UseLabel  AS ASCIIZ * 128
    CmdLine   AS ASCIIZ * 260
    ShowCmd   AS LONG
    hBitmap   AS LONG
    visible   AS BYTE
END TYPE

GLOBAL gS() AS gSpriteArrayStruct, gsFolderResource AS STRING
GLOBAL gbShortCutVisible, gbSoundActive, gnXoffset, gnMoveIcon, gnDraging, gnSelecting, gnRecycleBin, gnRecycleBinFull, gnUserFocus AS LONG
GLOBAL ghProgMan, ghListView, ghPopupMenu AS DWORD

SUB SetupAlphaChannel(BYVAL hDC AS LONG)
'   // We must do this to be compatible with BitBlt and Alphablend
'   // We compute a fake alpha channel based on color conversion to shade of gray
    LOCAL pBits AS BYTE PTR, bm AS BITMAP, P AS LONG
    CALL GetObject(GetCurrentObject(hDC, 7), SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (bm.bmWidth * bm.bmHeight) TO 1 STEP - 1
        Alpha& = Rgb2Gray(RGB(@pBits[2],@pBits[1],@pBits[0])) AND &H000000FF???
        IF Alpha& = 0 AND @pBits[3] = 0 THEN
           @pBits[3] = 0
        ELSE
           IF @pBits[3] = 0 THEN @pBits[3] = 255 ' // Setup the opacity level
        END IF
        pBits = pBits + 4
    NEXT
END SUB

DECLARE FUNCTION GdipDisposeImage LIB "gdiplus.dll" ALIAS "GdipDisposeImage" (BYVAL nImage&) AS LONG
FUNCTION CreateBarIcon(lpszFile AS ASCIIZ, nItem AS LONG) AS LONG
    LOCAL hIcon, hIconLarge, hIconSmall AS DWORD
    LOCAL IsBatchFile, DoIt AS LONG
    LOCAL ii AS ICONINFO

    IF LCASE$(RIGHT$(lpszFile, 4)) = ".bat" THEN IsBatchFile = -1
    IF LCASE$(RIGHT$(lpszFile, 4)) = ".png" THEN IsBatchFile = 1
    IF LCASE$(RIGHT$(lpszFile, 4)) = ".chm" THEN IsBatchFile = 3: lpszFile = "Help.png" ' // use the Help icon
    IF IsBatchFile = 0 THEN
       DoIt = ExtractIconEx(lpszFile, -1, 0, 0, 0)
       IF DoIt THEN
          CALL ExtractIconEx(lpszFile, 0, hIconLarge, hIconSmall, 1)
          IF hIconLarge THEN
             CALL GetIconInfo(hIconLarge, ii)
          ELSE
             CALL GetIconInfo(hIconSmall, ii)
          END IF
       ELSE
          IsBatchFile = 2 '// Unknown icon
          lpszFile = "Unknown.png"
       END IF
    END IF
    IF DoIt OR IsBatchFile THEN
       IF ii.hbmColor OR IsBatchFile THEN
          LOCAL bf AS BLENDFUNCTION
          LOCAL DesktopDC, hDCdest, hDCsrce, hBmp, Img, ImgW, ImgH, hDCtemp, hBmpTmp, hBat AS LONG
          DesktopDC = GetDC(0)

             hDCdest = CreateCompatibleDC(DesktopDC)
             hDCsrce = CreateCompatibleDC(DesktopDC)
             hBmp = ZI_CreateBitmapFromFile(gsFolderResource + "UseFrame.png", imgW, imgH)
             CALL SelectObject(hDCdest, hBmp)
             IF IsBatchFile = 0 THEN
                CALL SelectObject(hDCsrce, ii.hbmColor)
             ELSE
                IF IsBatchFile < 0 THEN
                   hBat = ZI_CreateBitmapFromFile(gsFolderResource + "Bat.png", imgW, imgH)
                ELSE
                   hBat = ZI_CreateBitmapFromFile(gsFolderResource + lpszFile, imgW, imgH)
                END IF
                CALL SelectObject(hDCsrce, hBat)
             END IF

             hDCtemp = CreateCompatibleDC(DesktopDC)
             CALL ZI_GetBitmapSize(ii.hbmColor, imgW, imgH)
             hBmpTmp = ZI_CreateDIBSection(DesktopDC, imgW, imgH, 32)
             CALL SelectObject(hDCtemp, hBmpTmp)
             CALL BitBlt(hDCtemp, 0, 0, imgW, imgH, hDCsrce, 0, 0, %SRCCOPY)
             CALL DeleteDC(hDCsrce)
             IF IsBatchFile THEN CALL DeleteObject(hBat)

             CALL SetupAlphaChannel(hDCtemp)
             CALL zAlphaBlend(hDCdest, 8, 8, 32, 32, hDCtemp, 0, 0, 32, 32)
             CALL DeleteDC(hDCtemp)
             CALL DeleteObject(hBmpTmp)

             Img = zBitmapToImage(hDCdest)
             CALL DeleteObject(hBmp)
             IF Img THEN
                CALL zSaveImageToFile(zGetTempPath() + "OfTheBay" + STR$(nItem) + ".png", Img, 0)
                CALL GdipDisposeImage(Img)
                FUNCTION = -1
             END IF

             CALL DeleteDC(hDCdest)
             CALL ReleaseDC(0, DesktopDC)

       END IF
       IF hIconLarge THEN DestroyIcon(hIconLarge)
       IF hIconSmall THEN DestroyIcon(hIconSmall)
    END IF

END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg           AS tagMsg
    LOCAL wc            AS WNDCLASSEX
    LOCAL zClass        AS ASCIIZ * 80
    LOCAL dwExStyle     AS DWORD
    LOCAL dwStyle       AS DWORD
    LOCAL rc            AS RECT
    LOCAL x             AS LONG
    LOCAL y             AS LONG
    LOCAL hMutex        AS DWORD
    LOCAL hFound        AS DWORD
    LOCAL hMain         AS DWORD
    LOCAL BarW, BarH    AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function

    LOCAL IsInitialized        AS LONG

    zClass = "ZDOCKBAY"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = 0'%CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF

     ' Window Extended Style
       dwExStyle = %WS_EX_LAYERED OR %WS_EX_TOOLWINDOW ' OR %WS_EX_TOPMOST
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %FRAME_SizeX, %FRAME_SizeY)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       IF GetToolBarSize(BarW, BarH) THEN
          y = GetSystemMetrics(%SM_CYSCREEN) - BarH - rc.nBottom - rc.nTop' - 3
       ELSE
          y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
       END IF
'
     ' Create The Window
       MyTitle$ = zClass
       hMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

          CALL DragAcceptFiles(hMain, %TRUE)

          gsFolderResource = EXE.Path$ + "Resource\"
          gbShortCutVisible = 0   '// Shortcut are hidden
          gbSoundActive     = -1  '// Sound is on

          CALL zsMainWindow(hMain) '// Save the main window handle for zSkin.inc

'         // GUI components section
          DIM gS(%LBOUND TO 0)
          gS(0).hBitmap = ZI_CreateBitmapFromFile((gsFolderResource + "UseBack.png"), gS(0).w, gS(0).h)
          gS(0).x = 0: gS(0).y = MAX&(%FRAME_SizeY - gS(0).h, 0): gS(0).opacity = 255

          gS(%ID_LEFT).x = 0: gS(%ID_LEFT).y = %FRAME_SizeY - 25: gS(%ID_LEFT).opacity = 128
          gS(%ID_LEFT).hBitmap = ZI_CreateBitmapFromFile((gsFolderResource + "Left.png"), gS(%ID_LEFT).w, gS(%ID_LEFT).h)

          gS(%ID_RIGHT).x = gS(0).w - gS(%ID_LEFT).w: gS(%ID_RIGHT).y = %FRAME_SizeY - 25: gS(%ID_RIGHT).opacity = 128
          gS(%ID_RIGHT).hBitmap = ZI_CreateBitmapFromFile((gsFolderResource + "Right.png"), gS(%ID_RIGHT).w, gS(%ID_RIGHT).h)

          gS(%ID_FLARE).x = 0: gS(%ID_FLARE).y = 16: gS(%ID_FLARE).opacity = 200
          gS(%ID_FLARE).hBitmap = ZI_CreateBitmapFromFile((gsFolderResource + "Flare.png"), gS(%ID_FLARE).w, gS(%ID_FLARE).h)

          gS(%ID_BLUEFLARE).hBitmap = ZI_CreateBitmapFromFile((gsFolderResource + "BlueFlare.png"), gS(%ID_BLUEFLARE).w, gS(%ID_BLUEFLARE).h)
          gS(%ID_BLUEFLARE).x = 0: gS(%ID_BLUEFLARE).y = %FRAME_SizeY - (gS(%ID_BLUEFLARE).h + 3): gS(%ID_BLUEFLARE).opacity = 255

          gS(%ID_FOCUS).hBitmap = ZI_CreateBitmapFromFile((gsFolderResource + "Focus.png"), gS(%ID_FOCUS).w, gS(%ID_FOCUS).h)
          gS(%ID_FOCUS).x = 0: gS(%ID_FOCUS).y = %FRAME_SizeY - (gS(%ID_FOCUS).h + 4): gS(%ID_FOCUS).opacity = 128

'         // --------------------------
          CALL CreateShortCut(hMain)

          '// Remove the ghListView current focus
          LOCAL XY AS LONG: XY = MAKLNG(-1, -1)
          CALL PostMessage (ghListView, 513 , 0, XY) '// WM_LBUTTONDOWN
          CALL PostMessage (ghListView, 514 , 0, XY) '// WM_LBUTTONUP
          CALL PostMessage (ghListView, 515 , 0, XY) '// WM_LBUTTONDBLCLK

          IF gbSoundActive THEN CALL Playsound("blup", zsInstance(), %SND_RESOURCE OR %SND_ASYNC)

          '// Hide desktop icons
          CALL ShowDesktopIcons(%FALSE)

          'CALL ShowWindow(hMain, %SW_SHOW)
          CALL AnimateWindow(hMain, 500, %AW_CENTER OR %AW_ACTIVATE)
          CALL UpdateTheWindow(hMain, 1)

          CALL SetTimer(hMain, 1, %TIMER_Speed, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
          WEND
          CALL KillTimer(hMain, 1)

          '// Show desktop icons
          CALL ShowDesktopIcons(%TRUE)

          '//FreeUp resources
          FOR x = LBOUND(gS) TO UBOUND(gS)
              IF gS(x).hBitmap THEN DeleteObject(gS(x).hBitmap): gS(x).hBitmap = 0
          NEXT

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

FUNCTION GetMouseMoveSpriteID(BYVAL hWnd AS LONG, lpX AS LONG, lpY AS LONG, BYVAL nHover AS DWORD) AS LONG
    LOCAL I, x, y, nHeight AS LONG
    LOCAL lp AS POINTAPI, rw, rc AS RECT

    IF nHover = 0 THEN
       CALL GetCursorPos(lp)
       nHover = WindowFromPoint(lp.X, lp.Y)
    ELSE
       lp.X = lpX: lp.Y = lpY
    END IF

    CALL ScreenToClient(hWnd, lp)
    lpX = lp.X: lpY = lp.Y

    IF ghPopupMenu THEN EXIT FUNCTION ' AND nHover = ghPopupMenu THEN EXIT FUNCTION

    CALL GetWindowRect(hWnd, rw)
    nHeight = (rw.nBottom - rw.nTop) - 28

    CALL SetRect(rc, 44, 0, gS(0).w - 44, nHeight)' 62)
    IF PtInRect(rc, lpX, lpY) THEN '// Mouse click must be done inside of the icon area
       FOR I = UBOUND(gS) TO 1 STEP -1
           x = gS(I).x: y = gS(I).y
           CALL SetRect(rc, x, y, x + gS(I).w, nHeight) ' 62)
           IF PtInRect(rc, lpX, lpY) THEN FUNCTION = I: EXIT FOR '// We found it
       NEXT
    END IF

END FUNCTION

SUB FireApplication(BYVAL nItem AS LONG)
    LOCAL sShellTo, sCmdLine, sFullPath AS STRING
    sShellTo = gS(nItem).ShellTo: IF INSTR(sShellTo, "{") THEN sShellTo = ""
    sFullPath = gS(nItem).WorkDir
    sCmdLine = gS(nItem).CmdLine
    REPLACE "/N;::" WITH "/N,::" IN sCmdLine

    IF LEN(sFullPath) = 0 THEN
       sFullPath = RTRIM$(PATHNAME$(PATH, sShellTo), "\")
    ELSE
       CALL SetCurrentDirectory((sFullPath))
    END IF
    CALL ShellExecute(0, "open", (sShellTo), (sCmdLine), (sFullPath), gS(nItem).ShowCmd)

END SUB

SUB MoveIcon(BYVAL Offset AS LONG)
    LOCAL K AS LONG
    FOR K = UBOUND(gS()) TO 1 STEP -1
        gS(K).x += Offset
    NEXT
END SUB

FUNCTION GetCtrlID(BYVAL lpX AS LONG, BYVAL lpY AS LONG) AS LONG
    LOCAL I, x, y AS LONG, rc AS RECT
    FOR I = -1 TO %LBOUND STEP -1
        IF gS(I).visible THEN ' // We do not want to check hidden controls
           x = gS(I).x: y = gS(I).y
           CALL SetRect(rc, x, y, x + gS(I).w, y + gS(I).h)
           IF PtInRect(rc, lpX, lpY) THEN FUNCTION = I: EXIT FOR
        END IF
    NEXT
END FUNCTION

FUNCTION GetMenuTxt(BYVAL ItemId AS LONG, Img AS LONG) AS STRING
    LOCAL sItem AS STRING
    IF IsFrench() = 0 THEN
       SELECT CASE ItemId
       CASE %IDM_About             : FUNCTION = "A propos"
       CASE %IDM_IconFrame         : FUNCTION = "Cadre des icnes"
       CASE %IDM_IconBack          : FUNCTION = "Arrire-plan des icnes"
       CASE %IDM_ShortCut          : IF gbShortCutVisible THEN FUNCTION = "Masquer les raccourcis" ELSE FUNCTION = "Montrer les raccourcis"
       CASE %IDM_Sound             : IF gbSoundActive THEN FUNCTION = "Dsactive le son" ELSE FUNCTION = "Active le son"
       CASE %IDM_Wallpaper         : FUNCTION = "Arrire-plan du bureau"
       CASE %IDM_BuildOTB          : FUNCTION = "Gnrer fichier OTB"
       CASE %IDM_Edit              : FUNCTION = "Editer le fichier OTB"
       CASE %IDM_Restart           : FUNCTION = "Redmarrer OTB"
       CASE %IDM_Close             : FUNCTION = "Fermer """ + $VERSION +""""

       END SELECT
    ELSE
       SELECT CASE ItemId
       CASE %IDM_About             : FUNCTION = "About"
       CASE %IDM_IconFrame         : FUNCTION = "Icon frame"
       CASE %IDM_IconBack          : FUNCTION = "Background layer"
       CASE %IDM_ShortCut          : IF gbShortCutVisible THEN FUNCTION = "Hide shor cut" ELSE FUNCTION = "Show short cut"
       CASE %IDM_Sound             : IF gbSoundActive THEN FUNCTION = "Disable sound" ELSE FUNCTION = "Enable sound"
       CASE %IDM_Wallpaper         : FUNCTION = "Change Wallpaper"
       CASE %IDM_BuildOTB          : FUNCTION = "Build the OTB file"
       CASE %IDM_Edit              : FUNCTION = "Edit the OTB file"
       CASE %IDM_Restart           : FUNCTION = "Restart OTB"
       CASE %IDM_Close             : FUNCTION = "Close """ + $VERSION + """"

       END SELECT
    END IF

    SELECT CASE ItemId
    CASE %IDM_About                : sItem = "About.png"
    CASE %IDM_IconFrame            : sItem = "IconFrame.png"
    CASE %IDM_IconBack             : sItem = "IconBack.png"
    CASE %IDM_ShortCut             : IF gbShortCutVisible THEN sItem = "ShortCutOff.png" ELSE sItem = "ShortCutOn.png"
    CASE %IDM_Sound                : IF gbSoundActive THEN sItem = "SoundOff.png" ELSE sItem = "SoundOn.png"
    CASE %IDM_Wallpaper            : sItem = "Miniature.png"
    CASE %IDM_BuildOTB             : sItem = "OTB.png"
    CASE %IDM_Edit                 : sItem = "Notepad.png"
    CASE %IDM_Restart              : sItem = "Restore.png"
    CASE %IDM_Close                : sItem = "Close.png"

    END SELECT
    Img = zsAddResource(EXE.Path$ + "Resource\" + sItem)

END FUNCTION

%OFN_FILEMUSTEXIST                              = &H00001000
%OFN_EXPLORER                                   = &H00080000 ' new look commdlg
%OFN_LONGNAMES                                  = &H00200000 ' force long names for 3.x modules
%OFN_EX_NOPLACESBAR                             = &H00000001

%WM_USERFOCUS = %WM_USER + 1

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL nObjectID AS LONG, p AS POINTAPI, sWasPath, sFileName, sCmdLine, sFilter, sString AS STRING
    LOCAL K, nOffset, nFilesDropped AS LONG, szFileName AS ASCIIZ * %MAX_PATH, szWallPaper AS ASCIIZ * %MAX_PATH

'   // This is to force a correct placement of the FileOpen/FileSave common dialog
'   // when using multiple display mode and working on the second display.
    STATIC dlgWnd, dlgX, dlgY AS LONG, dlgSleep AS DWORD
    IF dlgWnd THEN
       IF GetTickCount() > dlgSleep THEN
          CALL SetWindowPos(dlgWnd, dlgWnd, dlgX, dlgY, 0, 0, %SWP_NOZORDER OR %SWP_NOSIZE)
          dlgWnd = 0: dlgSleep = 0
       END IF
    END IF

    SELECT CASE LONG Msg

    CASE %WM_PRINT
         CALL DrawDockBar(hWnd, wParam, Msg, 0, 0, 0, 1)

    CASE %WM_USERFOCUS
         CALL SetWindowPos(hWnd, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOMOVE OR %SWP_NOSIZE)
         gnUserFocus = 0

    CASE %ZM_CENTER_DIALOG
         dlgWnd = wParam: dlgX = LO(INTEGER, lParam): dlgY = HI(INTEGER, lParam)
         dlgSleep = GetTickCount() + 30 ' 100
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_ACTIVATE
         CALL UpdateTheWindow(hWnd, 1)

    CASE %WM_DROPFILES '// Drag & drop
         nFilesDropped = DragQueryFile(wParam, -1, "", 0)
         IF nFilesDropped > 0 THEN
            FOR K = 0 TO nFilesDropped - 1
                CALL DragQueryFile(wParam, K, szFileName, %MAX_PATH)
                sCmdLine += $DQ + szFileName + $DQ + $SPC
            NEXT
            sCmdLine = RTRIM$(sCmdLine, $SPC)
         END IF
         CALL DragFinish(wParam)

         nObjectID = GetMouseMoveSpriteID(hWnd, 0, 0, 0)
         IF nObjectID > 0 AND LEN(sCmdLine) THEN
            gS(nObjectID).opacity = 50
            CALL UpdateTheWindow(hWnd, 1)
            IF gbSoundActive THEN CALL Playsound("blup", zsInstance(), %SND_RESOURCE OR %SND_ASYNC)

            CALL ShellExecute(0, "open", (gS(nObjectID).ShellTo), (sCmdLine), (gS(nObjectID).WorkDir), gS(nObjectID).ShowCmd)

         END IF

    CASE %WM_COMMAND
         'IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION
         SELECT CASE LONG LO(INTEGER, wParam)
         CASE %IDM_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION
         CASE %IDM_IconFrame
              gnSelecting = -1
              '// center the common dialog into the screen
              sWasPath = ZI_LoadSavePath("", 0): CALL ZI_LoadSavePath((EXE.Path$ + "Resource\IconFrame"), 1)
              CALL ZI_CenterDialog(1, 1): sFileName = ZI_LoadDialog(hWnd)
              'sFilter = ZI_SetLoadExtension("", 0)
              'REPLACE $zLim WITH $NUL IN sFilter: sFilter += $NUL
              'DISPLAY OPENFILE hWnd, , , EXE.Name$, EXE.Path$ + "Resource\IconFrame", _
              '                 sFilter$, "", "", %OFN_FILEMUSTEXIST OR %OFN_LONGNAMES OR %OFN_EXPLORER TO sFileName
              gnSelecting = 0

              IF LEN(sFileName) THEN
                 IF zsFileCopy(hWnd, (sFileName), (EXE.Path$ + "Resource\UseFrame.png"), "", 0) = 0 THEN
                    CALL CreateShortCut(hWnd)
                    CALL UpdateTheWindow(hWnd, 1)
                 END IF
              END IF
              '// Restore original path
              IF LEN(sWasPath) THEN CALL ZI_LoadSavePath((sWasPath), 1)
              FUNCTION = 0: EXIT FUNCTION
         CASE %IDM_IconBack
              gnSelecting = -1
              '// center the common dialog into the screen
              sWasPath = ZI_LoadSavePath("", 0): CALL ZI_LoadSavePath((EXE.Path$ + "Resource\Background"), 1)
              CALL ZI_CenterDialog(1, 1): sFileName = ZI_LoadDialog(hWnd)
              'sFilter = ZI_SetLoadExtension("", 0)
              'REPLACE $zLim WITH $NUL IN sFilter: sFilter += $NUL
              'DISPLAY OPENFILE hWnd, , , EXE.Name$, EXE.Path$ + "Resource\Background", _
              '                 sFilter$, "", "", %OFN_FILEMUSTEXIST OR %OFN_LONGNAMES OR %OFN_EXPLORER TO sFileName
              gnSelecting = 0
              IF LEN(sFileName) THEN
                 IF zsFileCopy(hWnd, (sFileName), (EXE.Path$ + "Resource\UseBack.png"), "", 0) = 0 THEN
                    IF gS(0).hBitmap THEN DeleteObject(gS(0).hBitmap): gS(0).hBitmap = 0
                    gS(0).hBitmap = ZI_CreateBitmapFromFile((gsFolderResource + "UseBack.png"), gS(0).w, gS(0).h)
                    gS(0).y = MAX&(%FRAME_SizeY - gS(0).h, 0)
                    CALL UpdateTheWindow(hWnd, 1)
                 END IF
              END IF
              '// Restore original path
              IF LEN(sWasPath) THEN CALL ZI_LoadSavePath((sWasPath), 1)
              FUNCTION = 0: EXIT FUNCTION
         CASE %IDM_ShortCut
              gbShortCutVisible = NOT gbShortCutVisible
              CALL ShowDesktopIcons(gbShortCutVisible)
         CASE %IDM_Sound
              gbSoundActive = NOT gbSoundActive
         CASE %IDM_Wallpaper
              gnSelecting = -1
              '// center the common dialog into the screen
              CALL ZI_CenterDialog(1, 1): szFileName = ZI_LoadDialog(hWnd)
              'sFilter = ZI_SetLoadExtension("", 0)
              'REPLACE $zLim WITH $NUL IN sFilter: sFilter += $NUL
              'DISPLAY OPENFILE hWnd, , , EXE.Name$, "", _
              '                 sFilter$, "*.*", "", %OFN_FILEMUSTEXIST OR %OFN_LONGNAMES OR %OFN_EXPLORER TO szFileName
              gnSelecting = 0
              IF LEN(szFileName) THEN
                 szWallPaper = zGetTempPath() + "OTBpaper.jpg"
                 IF zsFitToSize(szFileName, GetSystemMetrics(%SM_CXSCREEN), GetSystemMetrics(%SM_CYSCREEN), szWallPaper) THEN
                    CALL SystemParametersInfo(%SPI_SETDESKWALLPAPER, 0, szWallPaper, %SPIF_UPDATEINIFILE OR %SPIF_SENDWININICHANGE)
                 END IF
              END IF
              FUNCTION = 0: EXIT FUNCTION
         CASE %IDM_BuildOTB
              CALL DoOTB()
              FUNCTION = 0: EXIT FUNCTION
         CASE %IDM_Edit
              szFileName = EXE.Path$ + EXE.Name$ + ".OTB"
              IF ISFILE(szFileName) = 0 THEN
                 IF IsFrench() THEN
                    sString = "Le fichier OTB n'existe pas. Veuillez le crer au pralable."
                 ELSE
                    sString = "The OTB file doesn't exist. Please create it first."
                 END IF
                 MSGBOX sString, %MB_OK OR %MB_ICONINFORMATION, EXE.Name$      
              ELSE
                 CALL ShellExecute(0, "open", "Notepad.exe", szFileName, EXE.Path$, %SW_SHOW)
                 FUNCTION = 0: EXIT FUNCTION
              END IF
         CASE %IDM_Restart
              szFileName = EXE.Path$ + EXE.Name$ + ".OTB"
              IF ISFILE(szFileName) THEN CALL CreateShortCut(hWnd): CALL UpdateTheWindow(hWnd, 1)
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_CLOSE ' %ID_CLOSE
              CALL AnimateWindow(hWnd, 500, %AW_CENTER OR %AW_HIDE) '%AW_VER_POSITIVE OR %AW_ACTIVATE)
              CALL apiSleep(500)
              CALL PostMessage(hWnd, %WM_CLOSE, 0, 0)
         END SELECT

    CASE %WM_MEASUREITEM
         LOCAL lpmis AS MEASUREITEMSTRUCT PTR
         lpmis = lParam
         IF wParam = 0 THEN
            @lpmis.itemWidth = 120
            @lpmis.itemHeight = 18
            FUNCTION = 1: EXIT FUNCTION
         END IF

    CASE %WM_DRAWITEM
         LOCAL lpdis AS DRAWITEMSTRUCT PTR
         lpdis = lParam
         SELECT CASE LONG @lpdis.CtlType

         CASE %ODT_MENU     ' 1 Owner-drawn menu item
              LOCAL zTxt AS ASCIIZ * 128, nDrawIt, Img, imgW, imgH, graphics AS LONG

              ghPopupMenu = WinDowFromDC(@lpdis.hDC)

              zTxt = GetMenuTxt(@lpdis.ItemID, Img)
              nDrawIt = -1
              IF (@lpdis.itemState AND %ODS_SELECTED) THEN
                 CALL SetTextColor(@lpdis.hDC, 0)
                 CALL SetBkColor(@lpdis.hDC, RGB(170,173,185))
              ELSE
                 CALL SetTextColor(@lpdis.hDC, 0)
                 CALL SetBkColor(@lpdis.hDC, RGB(240,240,240))
              END IF

              IF (@lpdis.itemState AND %ODS_GRAYED) THEN
                 CALL SetTextColor(@lpdis.hDC, RGB(128,128,128))
                 nDrawIt = 0
              END IF

              CALL ExtTextOut(@lpdis.hDC, 6 + 16 + @lpdis.rcItem.nleft, _
                              @lpdis.rcItem.nTop + 3, %ETO_OPAQUE, _
                              @lpdis.rcItem, zTxt, LEN(zTxt), BYVAL 0)

              IF nDrawIt AND GdipCreateFromHDC(@lpdis.hDC, graphics) = 0 THEN
                 CALL zsGetImageSize(Img, imgW, imgH)
                 CALL GdipDrawImageRectRectI(graphics&, Img, _
                                             @lpdis.rcItem.nleft + 1, @lpdis.rcItem.nTop + 1, ImgW, ImgH, _
                                             0, 0, ImgW, ImgH, %UnitPixel, _
                                             0)
                 CALL GdipDeleteGraphics(graphics)
              END IF

              FUNCTION = 1: EXIT FUNCTION

         END SELECT

    CASE %WM_LBUTTONDOWN
         nObjectID = GetMouseMoveSpriteID(hWnd, 0, 0, 0)
         IF nObjectID > 0 THEN
            gS(nObjectID).opacity = 50
            CALL UpdateTheWindow(hWnd, 1)
            IF gbSoundActive THEN CALL Playsound("blup", zsInstance(), %SND_RESOURCE OR %SND_ASYNC)

            CALL FireApplication(nObjectID) '// <---- Start the application

         ELSE
            SELECT CASE LONG GetCtrlID(LO(INTEGER, lParam), HI(INTEGER, lParam))
            CASE %ID_RIGHT
                 IF gS(UBOUND(gS)).x > gS(0).w -88 THEN
                    gnXoffset = UBOUND(gS) - ((gS(0).w - 88) \ 48)
                    nOffset = ((gS(0).w - 88) \ 48) * 48 + 44
                    FOR K = UBOUND(gS()) TO 1 STEP -1
                        nOffset -= 48: gS(K).x = nOffset
                    NEXT
                    CALL UpdateTheWindow(hWnd, 1)
                    gnMoveIcon = 0
                 END IF
            CASE %ID_LEFT
                 IF gnXoffset THEN
                    gnXoffset = 0
                    nOffset = 44
                    FOR K = 1 TO UBOUND(gS())
                        gS(K).x = nOffset: nOffset += 48
                    NEXT
                    CALL UpdateTheWindow(hWnd, 1)
                    gnMoveIcon = 0
                 END IF
            CASE ELSE
                 gnDraging = -1
                 CALL SendMessage(hWnd, %WM_NCLBUTTONDOWN, %HTCAPTION, 0)
            END SELECT
         END IF

    CASE %WM_RBUTTONDOWN
         LOCAL hMenu, nChoice AS LONG
         nObjectID = GetMouseMoveSpriteID(hWnd, 0, 0, 0)
         IF nObjectID = 0 THEN
            hMenu = CreatePopupMenu() '// The bitmap popup menu
            IF hMenu THEN
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_About          , "")
               CALL AppendMenu(hMenu, %MF_SEPARATOR, 102                 , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_IconFrame      , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_IconBack       , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_ShortCut       , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_Sound          , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_Wallpaper      , "")
               CALL AppendMenu(hMenu, %MF_SEPARATOR, 108                 , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_BuildOTB       , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_Edit           , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_Restart        , "")
               CALL AppendMenu(hMenu, %MF_SEPARATOR, 112                 , "")
               CALL AppendMenu(hMenu, %MF_OWNERDRAW, %IDM_Close          , "")
               CALL GetCursorPos(p)
               nChoice = TrackPopupMenuEx(hMenu, %TPM_RETURNCMD, p.X, p.Y, hWnd, BYVAL %NULL)
               CALL DestroyMenu(hMenu)
               ghPopupMenu = 0
               IF nChoice THEN CALL SendMessage(hWnd, %WM_COMMAND, MAKLNG(nChoice, 0), 0)
            END IF
         ELSE
            CALL UpdateTheWindow(hWnd, 1) '//Show the full target path
         END IF

    CASE %WM_KEYDOWN
         IF wParam = &H1B& THEN '// VK_ESCAPE
            CALL DestroyWindow(hWnd)
         END IF

    CASE %WM_TIMER
         CALL UpdateTheWindow(hWnd, 0)

    CASE %WM_DESTROY
'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zsAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zsRemoveAllImageResource()

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
    'FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB DrawSprite(BYVAL hDCdest AS LONG, BYVAL I AS LONG, BYVAL Alpha AS LONG)

    LOCAL x, y, XW, YH, xx, yy, hDCsrce AS LONG

    XW = gS(I).w
    YH = gS(I).h
    x = gS(I).x
    y = gS(I).y

    IF I > 0 THEN
       IF x < 40 OR x > gS(0).w -88 THEN EXIT SUB
    END IF

    hDCsrce = CreateCompatibleDC(hDCdest)
    CALL SelectObject(hDCsrce, gS(I).hBitmap)

    IF gS(I).scale = 0 THEN gS(I).scale = 100
    XW = gS(I).w * (gS(I).scale / 100)
    YH = gS(I).h * (gS(I).scale / 100)
    xx = 0: yy = 0
    IF XW <> gS(I).w THEN
       xx = (gS(I).w - XW) \ 2
       yy = (gS(I).h - YH) \ 2
    END IF

    CALL ZI_AlphaBlendEx(hDCdest, x + xx, y + yy, XW, YH, hDCsrce, 0, 0, gS(I).w, gS(I).h, Alpha, 0, 2)

    CALL DeleteDC(hDCSrce)

END SUB

FUNCTION CreateDockIcon (zImgName AS ASCIIZ, imgW AS LONG, imgH AS LONG) AS LONG
    LOCAL graphics, x, y, W, H, UseImgH, hDC, ImgHDC, Img, hbmReturn AS LONG
    LOCAL Alpha AS BYTE, AlphaCoef, AlphaStep, UseStep AS SINGLE
    LOCAL pBits AS BYTE PTR, bm AS BITMAP

  ' Load image
    IF GdipLoadImageFromFile((UCODE$(zImgName)), Img) = 0 THEN
     ' Get the image height and width
       CALL zsGetImageSize(Img, imgW, imgH)

       hDC = zsDisplayDC()
       ImgHDC = CreateCompatibleDC(hDC)

       UseImgH& = imgH + (imgH \ 2)
       ' We must deal with 32-bit to handle the alpha channel
       hbmReturn = ZI_CreateDIBSection(hDC, imgW, UseImgH&, 32)

       CALL SelectObject(ImgHDC, hbmReturn)
       CALL DeleteDC(hDC)
     ' Draw image
       IF GdipCreateFromHDC(ImgHDC, graphics) = 0 THEN
          IF GdipDrawImageRectI(graphics, img, 0, 0, imgW, imgH) = 0 THEN

             CALL GetObject(hbmReturn, SIZEOF(bm), bm)
             pBits = bm.bmBits

           ' Flip image to create reflection
             CALL GdipImageRotateFlip(img, 6)
           ' Add reflection to bottom of original image
             CALL GdipDrawImageRectI(graphics, img, 0, imgH, imgW, imgH)
             W = imgW: H = imgH
             AlphaStep = 256
             UseStep = 128 / (UseImgH - H)
             FOR y = 0 TO UseImgH - H - 1
                 FOR x = 0 TO (W - 1)
                     Alpha = MAX&(@pBits[3] - CINT(AlphaStep), 0)
                     @pBits[3] = Alpha
                     pBits = pBits + 4
                 NEXT
                 AlphaStep -= UseStep
             NEXT

             FOR y = 0 TO H - 1
                 FOR x = 0 TO (W - 1)
                     AlphaCoef = (@pBits[3] / 255)
                     @pBits[2] = @pBits[2] / AlphaCoef
                     @pBits[1] = @pBits[1] / AlphaCoef
                     @pBits[0] = @pBits[0] / AlphaCoef
                     pBits = pBits + 4
                 NEXT
             NEXT

             imgH = UseImgH
             FUNCTION = hbmReturn
          END IF
        ' Cleanup
          CALL GdipDeleteGraphics(graphics)
       END IF
       CALL GdipDisposeImage(Img): Img = 0
       CALL DeleteDC(ImgHDC)

    END IF
END FUNCTION

FUNCTION CreateCustomIcon (zImgName AS ASCIIZ, imgW AS LONG, imgH AS LONG, BYVAL nItem AS LONG) AS LONG
    LOCAL DesktopDC, hDCframe, hDCicon, hDCbmp, hFrame, hIcon, hBitmap AS LONG

    CALL ZI_GetImageSizeFromFile(zImgName, imgW, imgH)
    IF imgW > 32 OR imgH > 32 THEN
       hBitmap = ZI_FitBitmapFromFile(zImgName, 48, 48)
    ELSE
       DesktopDC = GetDC(0)

       hDCframe = CreateCompatibleDC(DesktopDC)
       hDCicon = CreateCompatibleDC(DesktopDC)
       hFrame = ZI_CreateBitmapFromFile(gsFolderResource + "UseFrame.png", imgW, imgH)
       CALL SelectObject(hDCframe, hFrame)
       hIcon = ZI_FitBitmapFromFile(zImgName, 32, 32)
       CALL SelectObject(hDCicon, hIcon)

       hDCbmp = CreateCompatibleDC(DesktopDC)
       hBitmap = ZI_CreateDIBSection(DesktopDC, imgW, imgH, 32)
       CALL SelectObject(hDCbmp, hBitmap)

       CALL BitBlt(hDCbmp, 0, 0, imgW, imgH, hDCframe, 0, 0, %SRCCOPY)
       'CALL SetupAlphaChannel(hDCbmp)
       CALL zAlphaBlend(hDCbmp, 8, 8, 32, 32, hDCicon, 0, 0, 32, 32)

       CALL DeleteDC(hDCbmp)
       CALL DeleteObject(hIcon)
       CALL DeleteDC(hDCicon)
       CALL DeleteObject(hFrame)
       CALL DeleteDC(hDCframe)

       CALL ReleaseDC(0, DesktopDC)

    END IF

    zImgName = zGetTempPath() + "OfTheBay" + STR$(nItem) + ".png"
    CALL ZI_SaveBitmapToFile(zImgName, hBitmap, 0)
    CALL DeleteObject(hBitmap)

    FUNCTION = CreateDockIcon(zImgName, imgW, imgH)

END FUNCTION

SUB CreateShortCut(BYVAl hWnd AS LONG)

    LOCAL nFound, nCount, nLeft, nRight, nHeight, hBitmap, xOffset AS LONG
    LOCAL K, nItemCount, nCenter AS LONG, sLink, sUseThumb AS STRING
    LOCAL rw AS RECT

    gnXoffset = 0
    '//gS(%ID_LEFT).visible = 0
    '//gS(%ID_RIGHT).visible = 0
    IF UBOUND(gS) > 0 THEN '// Clear existing bitmap
       FOR K = 1 TO UBOUND(gS)
           IF gS(K).hBitmap THEN DeleteObject(gS(K).hBitmap): gS(K).hBitmap = 0
       NEXT
    END IF
    nCenter = (gS(0).w - 48) \ 2

    ghProgMan  = FindWindow("Progman", "Program Manager")
    ghListView = FindWindowEx(ghProgMan, 0, "SHELLDLL_DefView", "")
    ghListView = FindWindowEx(ghListView, 0, "SysListView32", "FolderView")
    nItemCount = SendMessage(ghListView, %LVM_GETITEMCOUNT, 0, 0)
    IF nItemCount THEN

       LOCAL pWsh AS IWshShell
       pWsh = NEWCOM "WScript.Shell"
       LOCAL pLnk AS IWshShortcut
'      Shortcut description:       ACODE$(pLnk.Description)
'      Shortcut working directory: ACODE$(pLnk.WorkingDirectory)
'      Shortcut arguments:         ACODE$(pLnk.Arguments)
'      Shortcut hot key:           ACODE$(pLnk.HotKey)
'      Shortcut icon location:     ACODE$(pLnk.IconLocation)
'      Shortcut target path:       ACODE$(pLnk.TargetPath)
'      Shortcut window style:      FORMAT$(pLnk.WindowStyle)

       LOCAL sDeskTopPub, sDeskTopAdm, sFullName, sTempPath AS STRING
       LOCAL DoLnk, nIconVisibleAtOnce AS LONG
       LOCAL szTxt AS ASCIIZ * %MAX_PATH

       'sDeskTopTray$ = zsFolderGet(&H000A) '// %CSIDL_BITBUCKET ' <desktop>\Recycle Bin
'      %CSIDL_STARTMENU            = &H000b  ' <user name>\Start Menu
'      %CSIDL_DESKTOPDIRECTORY     = &H0010  ' <user name>\Desktop
       sDeskTopAdm = zsFolderGet(%CSIDL_DESKTOP)
       sDeskTopPub = zsFolderGet(%CSIDL_COMMON_DESKTOPDIRECTORY)
       sTempPath = zGetTempPath()

       CALL GetWindowRect(hWnd, rw)
       nHeight = (rw.nBottom - rw.nTop) - 75

       '// Do "Recycle bin" first
       sTarget$ = "": szTxt = ShortCutDisplayName(%CSIDL_BITBUCKET): GOSUB ProcessPseudoLnk
       gnRecycleBin = nCount': gS(gnRecycleBin).IconPath = EXE.Path$ + "UserIcon\48x48\RecycleBinFull.png"
       IF gS(gnRecycleBin).hBitmap THEN DeleteObject(gS(gnRecycleBin).hBitmap): gS(gnRecycleBin).hBitmap = 0
       sUseThumb = "RecycleBinEmpty.png": gnRecycleBinFull = 0
       IF SHGetRecycleBinCount() THEN sUseThumb = "RecycleBinFull.png": gnRecycleBinFull = -1
       gS(gnRecycleBin).IconPath = EXE.Path$ + "UserIcon\48x48\" + sUseThumb
       gS(gnRecycleBin).hBitmap = CreateCustomIcon((gS(gnRecycleBin).IconPath), gS(gnRecycleBin).w, gS(gnRecycleBin).h, 0)
       gS(gnRecycleBin).ShellTo = "explorer.exe"
       gS(gnRecycleBin).CmdLine = "/N;::{645FF040-5081-101B-9F08-00AA002F954E}" '// "/N,::{645FF040-5081-101B-9F08-00AA002F954E}"
       gS(gnRecycleBin).ShowCmd = %SW_SHOW
       '// End Recycle bin

       sFullName = sDeskTopAdm + "*.lnk"
       slink = DIR$(sFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
       DO WHILE LEN(sLink)
          sFullName = sDeskTopAdm + sLink: GOSUB ProcessLnk
          sLink = DIR$
       LOOP

       sFullName = sDeskTopPub + "*.lnk"
       slink = DIR$(sFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
       DO WHILE LEN(sLink)
          sFullName = sDeskTopPub + sLink: GOSUB ProcessLnk
          sLink = DIR$
       LOOP

'      ****************************************************
'      Check for OTB file, and read/add custom shortcuts
       CALL ReadCustomShortcuts(nFound, nCount, nHeight)
'      ****************************************************
       '// Setup icon x location
       nIconVisibleAtOnce = (gS(0).w - 88) \ 48
       xOffset = 44
       IF nCount < nIconVisibleAtOnce + 1 THEN
          xOffset += ((gS(0).w - 88) - (48 * nCount)) \ 2
       END IF
       FOR K = 1 TO nCount
           gS(K).x = xOffset + (48 * (K - 1))
       NEXT

    END IF

    EXIT SUB

ProcessLnk:
    szTxt = PATHNAME$(NAME, sLink)
    pLnk = pWsh.CreateShortcut(UCODE$(sFullName))
    sTarget$ = RTRIM$(ACODE$(pLnk.TargetPath))

'af$ = sFullName +$cr + sTarget$ + $cr + _
'      "Shortcut description: >" +      ACODE$(pLnk.Description)+"<"+$cr+ _
'      "Shortcut working directory: >" +ACODE$(pLnk.WorkingDirectory)+"<"+$cr+ _
'      "Shortcut arguments: >" +        ACODE$(pLnk.Arguments)+"<"+$cr+ _
'      "Shortcut hot key: >" +          ACODE$(pLnk.HotKey)+"<"+$cr+ _
'      "Shortcut icon location: >" +    ACODE$(pLnk.IconLocation)+"<"+$cr+ _
'      "Shortcut target path: >" +      ACODE$(pLnk.TargetPath)+"<"+$cr+ _
'      "Shortcut window style: >" +     FORMAT$(pLnk.WindowStyle)+"<"
'msgbox Af$

ProcessPseudoLnk:
    DoLnk = -1
    IF LEN(sTarget$) = 0 THEN
       sTarget$ = ResolveShortcutName(szTxt)
       IF LEN(sTarget$) = 0 THEN sTarget$ = ResolveLnk((sFullName)) ELSE DoLnk = 0
    ELSEIF LCASE$(sTarget$) = LCASE$(EXE.FULL$) THEN
       sTarget$ = ""
    END IF

    IF LEN(sTarget$) THEN
       LOCAL sIconSearch AS STRING
       sIconSearch = ""
       IF DoLnk THEN sIconSearch = LCASE$(EXTRACT$(ACODE$(pLnk.IconLocation), ",")): IF RIGHT$(sIconSearch, 4) <> ".ico" THEN sIconSearch = ""
       IF LEN(sIconSearch) = 0 THEN sIconSearch = sTarget$
       INCR nFound
       IF CreateBarIcon((sIconSearch), nFound) THEN
          INCR nCount
          REDIM PRESERVE gS(%LBOUND TO nCount)
          gS(nCount).y = nHeight: gs(nCount).scale = %SCALE_DEFAULT: gS(nCount).opacity = 255
          sUseThumb = sTempPath + "OfTheBay" + STR$(nFound) + ".png"
          gS(nCount).hBitmap = CreateDockIcon((sUseThumb), gS(nCount).w, gS(nCount).h)
          CALL zKillFile((sUseThumb))
          IF DoLnk THEN gS(nCount).ShellTo = LCASE$(sTarget$)
          IF DoLnk THEN gS(nCount).WorkDir = ACODE$(pLnk.WorkingDirectory)
          IF DoLnk THEN gS(nCount).CmdLine = ACODE$(pLnk.Arguments)
          gS(nCount).UseLabel = szTxt
          IF DoLnk THEN gS(nCount).ShowCmd = pLnk.WindowStyle


          '// Check for "My computer"
          IF gS(nCount).UseLabel = ShortCutDisplayName(%CSIDL_DRIVES) THEN
             gS(nCount).ShellTo = "explorer.exe"
             gS(nCount).CmdLine = "/N;::{20d04fe0-3aea-1069-a2d8-08002b30309d}" '// "/N,::{20d04fe0-3aea-1069-a2d8-08002b30309d}"
             gS(nCount).ShowCmd = %SW_SHOW
          END IF

       END IF
    END IF

RETURN

END SUB

SUB UpdateTheWindow(BYVAL hWnd AS LONG, BYVAL DrawIt AS LONG) 'static
    LOCAL DesktopDC, nObjectID, lpX, lpY, nCtrlID, x, y, hFocus AS LONG
    LOCAL nHover AS DWORD, rw, trcWork AS RECT

    STATIC nInflateID, nFlip, mX, mY, DoIt, WasID, hFound, RecycleBinCount AS LONG

    '// Don't update the display while we are using a common open.save dialog.
    IF gnSelecting THEN EXIT SUB

    IF gnRecycleBin THEN
       INCR RecycleBinCount
       IF RecycleBinCount > 100 THEN
          RecycleBinCount = 0
          LOCAL sUseThumb AS STRING
          IF SHGetRecycleBinCount() THEN
             IF gnRecycleBinFull = 0 THEN
                IF gS(gnRecycleBin).hBitmap THEN DeleteObject(gS(gnRecycleBin).hBitmap): gS(gnRecycleBin).hBitmap = 0
                sUseThumb = PATHNAME$(PATH, gS(gnRecycleBin).IconPath) + "RecycleBinFull.png"
                gS(gnRecycleBin).IconPath = sUseThumb
                gS(gnRecycleBin).hBitmap = CreateCustomIcon((sUseThumb), gS(gnRecycleBin).w, gS(gnRecycleBin).h, 0)
                gnRecycleBinFull = -1
                DrawIt = -1
             END IF
          ELSE
             IF gnRecycleBinFull THEN
                IF gS(gnRecycleBin).hBitmap THEN DeleteObject(gS(gnRecycleBin).hBitmap): gS(gnRecycleBin).hBitmap = 0
                sUseThumb = PATHNAME$(PATH, gS(gnRecycleBin).IconPath) + "RecycleBinEmpty.png"
                gS(gnRecycleBin).IconPath = sUseThumb
                gS(gnRecycleBin).hBitmap = CreateCustomIcon((sUseThumb), gS(gnRecycleBin).w, gS(gnRecycleBin).h, 0)
                gnRecycleBinFull = 0
                DrawIt = -1
             END IF
          END IF
       END IF
    END IF

    IF DrawIt = 0 AND gnMoveIcon = 0 THEN
       nFlip = NOT nFlip: IF nFlip THEN EXIT SUB
    END IF

    hFocus = GetForegroundWindow()
    IF hFocus = ghProgMan THEN
       IF ZI_IsLButtonDown THEN' CALL SetForeGroundWindow(hWnd)
          IF gnUserFocus = 0 THEN
             gnUserFocus = -1
             CALL SetWindowPos(hWnd, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE OR %SWP_NOSIZE)
             CALL PostMessage (hWnd, %WM_USERFOCUS, 0, 0)
          END IF
       END IF
    END IF

'// To popup OTB when the user click on the desktop
    IF gnDraging THEN
       IF ZI_IsLButtonDown = 0 THEN gnDraging = 0: DrawIt = 1
    END IF

    nObjectID = GetMouseMoveSpriteID(hWnd, lpX, lpY, nHover)
    IF nInflateID <> nObjectID THEN
       nInflateID = nObjectID
    END IF

'   // Smooth scrolling
    IF gnMoveIcon THEN
       DrawIt = -1
       IF gnMoveIcon < 0 THEN
          CALL MoveIcon(-%SMOOTH_STEP): gnMoveIcon += %SMOOTH_STEP
       ELSEIF gnMoveIcon > 0 THEN
          CALL MoveIcon(%SMOOTH_STEP): gnMoveIcon -= %SMOOTH_STEP
       END IF
    END IF
    IF nObjectID = 0 AND DrawIt = 0 THEN
       IF gnMoveIcon = 0 THEN
          nCtrlID = GetCtrlID(lpX, lpY)
          IF nCtrlID = %ID_LEFT THEN
             IF gnXoffset THEN
                DECR gnXoffset: gnMoveIcon = 48
             END IF
          ELSEIF nCtrlID = %ID_RIGHT THEN
             IF gS(UBOUND(gS)).x > gS(0).w -88 THEN
                INCR gnXoffset: gnMoveIcon = -48
             END IF
          END IF
       END IF
    END IF

'   // Avoid to hog the CPU
    IF DoIt = 0 AND DrawIt = 0 THEN
       IF lpX = mX AND lpY = mY THEN EXIT SUB
       IF WasID = nObjectID THEN EXIT SUB
    END IF

    DesktopDC = GetDC(0)
    CALL DrawDockBar(hWnd, DesktopDC, 0, lpX, lpY, nInflateID, DoIt)
    CALL ReleaseDC(0, DesktopDC)

    mX = lpX: mY = lpY
    WasID = nObjectID
END SUB

FUNCTION CheckTaskBarLocation(rw AS RECT) AS LONG
    LOCAL rwResult, rwTB AS RECT
    STATIC hTaskBar AS DWORD
    IF hTaskBar = 0 THEN hTaskBar = FindWindow("Shell_TrayWnd", "")
    IF hTaskBar THEN
       CALL GetWindowRect(hTaskBar, rwTB)
       IF InterSectRect(rwResult, rw, rwTB) THEN
          IF rwTB.nRight - rwTB.nLeft > rwTB.nBottom - rwTB.nTop THEN
             FUNCTION = rwResult.nBottom - rwResult.nTop
          END IF
       END IF
    END IF
END FUNCTION

SUB DrawDockBar(BYVAL hWnd AS LONG, BYVAL DesktopDC AS LONG, BYVAL Msg AS LONG, lpX AS LONG, lpY AS LONG, BYVAL nInflateID AS LONG, DoIt AS LONG)

    LOCAL K, x, y, nScale AS LONG
    LOCAL rw AS RECT
    LOCAL bf AS BLENDFUNCTION
    LOCAL lp, ptSrc AS POINTAPI
    LOCAL ls AS SIZEL
    LOCAL hBmp, hDC, bW, bH AS LONG
    LOCAL sCaption AS STRING, nColor, n3D, nSize AS LONG
    LOCAL nObjectID, nAlpha AS LONG

    CALL GetWindowRect(hWnd, rw)
    ls.Cx = rw.nRight - rw.nLeft: ls.Cy = rw.nBottom - rw.nTop
    lp.X = rw.nLeft: lp.Y = rw.nTop

    '// Draw active frame to new memory DC
    hDC = CreateCompatibleDC(DesktopDC)
    hBmp = ZI_CreateDIBSection(DesktopDC, ls.Cx, ls.CY, 32)
    CALL SelectObject(hDC, hBmp)

    CALL DrawSprite(hDC, 0, 255)

    DoIt = 0
    FOR K = 1 TO UBOUND(gS())
        IF nInflateID = K THEN
           IF gS(K).scale < %SCALE_MAX THEN gS(K).scale = gS(K).scale + %SCALE_STEP: DoIt = -1
        ELSE
           IF gS(K).scale > %SCALE_DEFAULT THEN gS(K).scale = gS(K).scale - %SCALE_STEP: DoIt = -1
        END IF

        nAlpha = gs(K).opacity: IF nAlpha < 255 THEN gs(K).opacity = nAlpha + 5: DoIt = -1

        CALL DrawSprite(hDC, K, nAlpha)
    NEXT
    IF DoIt THEN lpX = 0: lpY = 0

    IF gS(1).x < 40 THEN gS(%ID_LEFT).visible = 1 ELSE gS(%ID_LEFT).visible = 0
    IF gS(UBOUND(gS)).x > gS(0).w -88 THEN gS(%ID_RIGHT).visible = 1 ELSE gS(%ID_RIGHT).visible = 0

    IF gS(%ID_LEFT).visible THEN CALL DrawSprite(hDC, %ID_LEFT, gS(%ID_LEFT).opacity)
    IF gS(%ID_RIGHT).visible THEN CALL DrawSprite(hDC, %ID_RIGHT, gS(%ID_RIGHT).opacity)

    IF hWnd = GetForegroundWindow() THEN
       CALL DrawSprite(hDC, %ID_FOCUS, gS(%ID_FOCUS).opacity)
    END IF

    IF nInflateID THEN '// Display the caption label
       nScale = (gS(nInflateID).w - (gS(nInflateID).w * (gS(nInflateID).scale / 100))) \ 2
       gS(%ID_FLARE).x = gs(nInflateID).x + 16 - nScale
       gS(%ID_FLARE).y = ls.Cy - (88 - nScale)
       CALL DrawSprite(hDC, %ID_FLARE, gS(%ID_FLARE).opacity)

       gS(%ID_BLUEFLARE).x = gs(nInflateID).x + 10
       CALL DrawSprite(hDC, %ID_BLUEFLARE, gS(%ID_BLUEFLARE).opacity)

       IF ZI_IsRButtonDown() THEN sCaption = gS(nInflateID).ShellTo '//Show the full target path
       IF LEN(sCaption) = 0 THEN sCaption = gS(nInflateID).UseLabel '//ELSE show the shortcut name
       nColor = zsARGB(255,255,255,255): n3D = 1: nSize = %FONTSIZE

       CALL ZD_GetTextBound((sCaption), $USEFONT, nSize, bW, bH, %ZD_TextHorzUp)
       x = gS(nInflateID).x + 24 - (bW \ 2) ' (gS(0).w - bW) \ 2
       IF x < 0 THEN x = 0
       IF x + bW > 1000 THEN x = 1000 - bW
       y = ls.Cy - 25

'      // Darken text background to enhance readability while hover lighter background
       LOCAL nbW, nbH, hDCtxt, hBmptxt, nBackColor AS LONG
       CALL ZD_GetTextBound((sCaption), $USEFONT, 6, nbW, nbH, %ZD_TextHorzUp)
       hDCtxt = CreateCompatibleDC(DesktopDC)
       hBmptxt = ZI_CreateDIBSection(DesktopDC, nbW, nbH, 32)
       CALL SelectObject(hDCtxt, hBmptxt)
       nBackColor = zsARGB(128,255,255,0)
       CALL ZI_GradientPaintDC(hDCtxt&, 2, 3, nbW - 4, 3, nBackColor, nBackColor)
       CALL ZD_DrawTextToDC(hDCtxt&, (sCaption), 0, 0, zsARGB(255,0,0,0), $USEFONT, 6, 0, %ZD_TextHorzUp)
       CALL ZI_AlphaBlendEx(hDC, x , y - 2, bW + 1, bH + 4, hDCtxt, 0, 0, nbW, nbH, 200, 0, 2)
       CALL DeleteDC(hDCtxt)
       CALL DeleteObject(hBmptxt)

       CALL ZD_DrawTextToDC(hDC, (sCaption), _
                            x, _                         ' X coordinate
                            y, _                         ' Y coordinate
                            nColor, _                    ' ARGB color
                            $USEFONT, _                  ' "Trebuchet MS"
                            nSize, _                     ' Font size in pixel
                            n3D, _                       ' Offset (in pixel) for 3D shadow effect
                            %ZD_TextHorzUp)              ' Orientation
    END IF

    IF Msg = %WM_PRINT THEN
       CALL BitBlt(DesktopDC, 0, 0, ls.CX, ls.CY, hDC, 0, 0, %SRCCOPY)
    ELSE
       bf.BlendOp             = &H00 ' %AC_SRC_OVER
       bf.BlendFlags          = 0
       bf.AlphaFormat         = &H01 ' %AC_SRC_ALPHA
       bf.SourceConstantAlpha = 255  ' Alpha
       CALL UpdateLayeredWindow (hWnd, DesktopDC, lp, ls, hDC, ptSrc, 0, bf, &H00000002) ' %ULW_ALPHA)
    END IF

    CALL DeleteObject(hBmp)
    CALL DeleteDC(hDC)

    LOCAL nDelta AS LONG
    nDelta = CheckTaskBarLocation(rw)
    IF nDelta THEN
       'CALL SetWindowPos(hWnd, hWnd, rw.nLeft, rw.nTop - nDelta, 0, 0, %SWP_NOZORDER OR %SWP_NOSIZE)
       CALL SetWindowPos(hWnd, hWnd, rw.nLeft, GetSystemMetrics(%SM_CYSCREEN) - GetToolBarSize(0,0) - %FRAME_SizeY, 0, 0, %SWP_NOZORDER OR %SWP_NOSIZE)
    END IF

END SUB

SUB ReadCustomShortcuts(BYREF nFound AS LONG, BYREF nCount AS LONG, BYVAl nHeight AS LONG)

    LOCAL zConfigFile AS ASCIIZ * %MAX_PATH
    LOCAL K, Item, S1, S2, S3, MiC, Ugs, FlagFound, Done, EnableFlag AS LONG
    LOCAL sCfg, sBF, sShellTo, sUseThumb, sUseLabel, sWorkDir, sEnable AS STRING
    zConfigFile = EXE.Path$ + EXE.Name$ + ".OTB"
    IF ISFILE(zConfigFile) THEN

       '// Make sure the current directory matches the EXE path
       CALL SetCurrentDirectory((EXE.Path$))

       Item = 0
       DO WHILE Done = 0
          sCfg = LTRIM$(zsBufin(zConfigFile, Done))
          IF LEN(sCfg) THEN
             IF ASC(LTRIM$(sCfg)) = 39 THEN sCfg = "" ' "'"
             S1 = INSTR(sCfg, "`")
             S2 = INSTR(-1, sCfg, CHR$(34))
             IF S1 = 0 THEN
                S3 = INSTR(-1, sCfg, "'"): IF S3 > S2 THEN S1 = S3
             END IF
             IF S1 THEN sCfg = RTRIM$(LEFT$(sCfg, S1 - 1))
             S1 = INSTR(sCfg, CHR$(34))
             IF S1 AND S1 < S2 THEN
                MiC = ASC(sCfg, LEN(sCfg))
                sCfg = MID$(sCfg, S1 + 1, S2 - S1 - 1)

                sBF = sBF + sCfg
                IF MiC <> 95 THEN
                   INCR Item
                   'sBF = zsOTBpath(sBF, EXE.Path$)
                   sShellTo = TRIM$(LCASE$(PARSE$(sBF, 1)))
                   sUseLabel = TRIM$(PARSE$(sBF, 2))
                   sUseThumb = zsOTBpath(TRIM$(PARSE$(sBF, 3)), EXE.Path$)
                   sWorkDir = zsOTBpath(TRIM$(PARSE$(sBF, 4)), PATHNAME$(PATH, sShellTo))
                   sEnable = TRIM$(PARSE$(sBF, 6))
                   IF LEN(sEnable) = 0 THEN EnableFlag = 1 ELSE EnableFlag = VAL(sEnable)
                   IF EnableFlag = 2 THEN ' RecycleBin
                      sUseThumb = PATHNAME$(PATH, sUseThumb)
                      IF SHGetRecycleBinCount() > 0 THEN
                         sUseThumb += "RecycleBinFull.png"
                         gnRecycleBinFull = -1
                      ELSE
                         sUseThumb += "RecycleBinEmpty.png"
                         gnRecycleBinFull = 0
                      END IF
                   END IF
'                  -----------------------
                   Ugs = UBOUND(gS())
                   FlagFound = 0
                   FOR K = 1 TO Ugs
                       'IF LEN(gS(K).ShellTo) = 0 THEN
                          IF LCASE$(gS(K).UseLabel) = LCASE$(sUseLabel) THEN FlagFound = K: EXIT FOR
                       'ELSE
                       '   IF gS(K).ShellTo = sShellTo THEN FlagFound = K: EXIT FOR
                       'END IF
                   NEXT
                   IF FlagFound THEN
                      IF EnableFlag THEN
                         IF ISFILE(sUseThumb) THEN
                            IF INSTR(sUseThumb, "?") = 0 THEN
                               INCR nFound
                               IF gS(FlagFound).hBitmap THEN DeleteObject(gS(FlagFound).hBitmap): gS(FlagFound).hBitmap = 0
                               gS(FlagFound).IconPath = sUseThumb
                               gS(FlagFound).hBitmap = CreateCustomIcon((sUseThumb), gS(FlagFound).w, gS(FlagFound).h, nFound)
                            END IF
                            gS(FlagFound).ShellTo = sShellTo
                            gS(FlagFound).WorkDir = sWorkDir
                            gS(FlagFound).UseLabel = sUseLabel

                            '// SWAP ITEM
                            IF Item <> FlagFound THEN SWAP gS(FlagFound),gS(Item): FlagFound = Item

                            IF EnableFlag = 2 THEN gnRecycleBin = FlagFound

                         END IF
                      ELSE '// We should disable (hide) this shortcut
                         IF gS(FlagFound).hBitmap THEN DeleteObject(gS(FlagFound).hBitmap): gS(FlagFound).hBitmap = 0
                      END IF
                   ELSEIF EnableFlag THEN
                      INCR nFound
                      INCR nCount
                      REDIM PRESERVE gS(%LBOUND TO nCount)
                      gS(nCount).y = nHeight: gs(nCount).scale = %SCALE_DEFAULT: gS(nCount).opacity = 255
                      gS(nCount).IconPath = sUseThumb
                      gS(nCount).hBitmap = CreateCustomIcon((sUseThumb), gS(nCount).w, gS(nCount).h, nFound)
                      gS(nCount).ShellTo = sShellTo
                      gS(nCount).WorkDir = sWorkDir
                      gS(nCount).UseLabel = sUseLabel
                      gS(nCount).ShowCmd = %SW_SHOW
                      IF EnableFlag = 2 THEN gnRecycleBin = nCount
                   END IF
'                  -----------------------

                   sBF = ""
                END IF
             END IF
          END IF
       LOOP

       '// Detect if we must disable (hide) some of the shortcuts.
       Ugs = UBOUND(gS())
       FOR K = Ugs TO 1 STEP -1
           IF gS(K).hBitmap = 0 THEN ARRAY DELETE gS(K): DECR nCount: IF gnRecycleBin = K THEN gnRecycleBin = 0
           IF gnRecycleBin > nCount THEN gnRecycleBin = nCount '// The RecycleBin array location must change accordingly
       NEXT
       IF UBOUND(gS()) > nCount THEN REDIM PRESERVE gS(%LBOUND TO nCount)

    END IF

END SUB

SUB WriteOTB(BYVAL sMsg AS STRING) STATIC
    DIM szFileName AS ASCIIZ * %MAX_PATH
    DIM hDebug AS LONG
    DIM NeverBeenThere AS LONG
    IF hDebug AND LEN(sMsg$) = 0 THEN
       CALL zsFClose(hDebug)
       NeverBeenThere = 0
       EXIT SUB
    END IF
    IF NeverBeenThere = 0 THEN
       NeverBeenThere = -1
       szFileName = EXE.Path$ + EXE.Name$ + ".OTB"
       CALL zsKillFile(szFileName)
       CALL zsFOpen(szFileName, 2, 4, hDebug)
    END IF
    CALL zsFPut(hDebug, sMsg + $CRLF)
END SUB

SUB DoOTB()
    LOCAL K, nCount AS LONG, sString AS STRING, Item AS gSpriteArrayStruct
    nCount = UBOUND(gS())
    IF nCount THEN

       WriteOTB "'+--------------------------------------------------------------------------+"
       WriteOTB "'|                               Of The Bay                                 |"
       WriteOTB "'|                                                                          |"
       WriteOTB "'|                         User shorcut definition                          |"
       WriteOTB "'|                                                                          |"
       WriteOTB "'+--------------------------------------------------------------------------+"
       WriteOTB "'|                                                                          |"
       WriteOTB "'|                         Author Patrice TERRIER                           |"
       WriteOTB "'|                            copyright(c) " + RIGHT$(DATE$, 4) + "                             |"
       WriteOTB "'|                           www.zapsolution.com                            |"
       WriteOTB "'|                         support@zapsolution.com                          |"
       WriteOTB "'|                                                                          |"
       WriteOTB "'+--------------------------------------------------------------------------+"
       WriteOTB "'| Build on: " + DATE$ + "                                                     |"
       WriteOTB "'+--------------------------------------------------------------------------+"
       WriteOTB "'"
       WriteOTB "'Use @PATH@ to match either the OfTheBay.EXE path or the ShellTo target path"
       WriteOTB "'"
       WriteOTB "'Icon:"
       WriteOTB "'Use either 32x32 or larger (will be converted to 48x48)"
       WriteOTB "'in case of 32x32 the program adds the active icon background else not."
       WriteOTB "'"
       WriteOTB "'""ShellTo, UseLabel, IconName, WorkDir, CmdLine, EnableShortcutTrueFalse"""
       WriteOTB "'"
       WriteOTB "'EnableShortcutTrueFalse = 0 // Disable this shorcut"
       WriteOTB "'EnableShortcutTrueFalse = 1 // Enable this shorcut"
       WriteOTB "'EnableShortcutTrueFalse = 2 // To inform OTB that this one refers to the ""Recycle Bin"""
       WriteOTB "'                            // you must also provide 2 icons named:"
       WriteOTB "'                            // ""RecycleBinEmpy.png"" and ""RecycleBinFull.png"""
       WriteOTB "'"
       WriteOTB "'Replace ""@PATH@UserIcon\48x48\????.png"" with a custom PNG file."
       WriteOTB "'"
       WriteOTB "'****************************************************************************"
       FOR K = 1 TO nCount
           Item = gS(K)
           IF K = gnRecycleBin THEN sString = ", 2""" ELSE sString = ", 1"""
           IF LEN(Item.ShellTo) = 0 THEN
              Item.ShellTo = Item.UseLabel
           ELSE
              IF INSTR(Item.ShellTo, "ofthebay.exe") THEN sString = ", 0""" ' Don't show it
              IF PATHNAME$(PATH, Item.ShellTo) = RTRIM$(LCASE$(Item.WorkDir), "\") + "\" THEN Item.WorkDir = "@PATH@"
           END IF
           IF LEN(Item.IconPath) = 0 THEN Item.IconPath = "@PATH@UserIcon\48x48\????.png"
           'WriteOTB """" + Item.ShellTo + ", " + Item.UseLabel + ", " + Item.IconPath + ", " + Item.WorkDir + ", " + Item.CmdLine + sString
           WriteOTB """" + Item.ShellTo + ", " + Item.UseLabel + ", " + zsPathOTB(EXE.Path$, Item.IconPath) + ", " + Item.WorkDir + ", " + Item.CmdLine + sString
       NEXT
       WriteOTB "'"
       WriteOTB "'End of file."

       WriteOTB "" '// Close the file

       sString = EXE.Path$ + EXE.Name$ + ".OTB"
       IF IsFrench() THEN
          sString = "Le fichier OTB est gnr, il se nomme :" + $CR + $CR + sString + $CR + $CR + $CR + "Utilisez un diteur de texte ASCII pour le personnaliser." + $CR + "Puis redmarrez ""OfTheBay""."
       ELSE
          sString = "OTB file has been saved under the name of:" + $CR + $CR + sString + $CR + $CR + $CR + "You can customize it with any ASCII text editor." + $CR + "Then restart ""OfTheBay""."
       END IF
       MSGBOX sString, %MB_OK OR %MB_ICONINFORMATION, EXE.Name$

    END IF

END SUB

'    LOCAL LIF AS LASTINPUTINFO
'    LIF.cbSize = SIZEOF(LASTINPUTINFO)
'    IF GetLastInputInfo(LIF) THEN
'       IF GetTickCount - LIF.dwTime > 1000 THEN
'       ELSE
'       END IF
'    END IF

