'+--------------------------------------------------------------------------+
'|                                                                          |
'|                 This include file is specific to DockBar.                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-27-2008 (MM-DD-YYYY)            |
'|                        Last revised : 11-21-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

' ########################################################################################
' Library name: IWshRuntimeLibrary
' Version: 1.0
' Documentation string: Windows Script Host Object Model
' Path: C:\WINDOWS\system32\wshom.ocx
' Library GUID: {F935DC20-1CF0-11D0-ADB9-00C04FD58A0B}
' ########################################################################################

#IF NOT %DEF(%WSHOM_INC)
    %WSHOM_INC = 1

'#INCLUDE ONCE "scrrun.inc"
'/////////////////////////////////////////////////////////////////////////////////////////
' ########################################################################################
' Library name: Scripting
' Version: 1.0
' Documentation string: Microsoft Scripting Runtime
' Path: C:\WINDOWS\system32\scrrun.dll
' Library GUID: {420B2830-E718-11CF-893D-00A0C9054228}
' Help file: C:\WINDOWS\system32\VBENLR98.CHM
' ########################################################################################

#IF NOT %DEF(%SCRRUN_INC)
    %SCRRUN_INC = 1

' ========================================================================================
' ProgIDs (Program identifiers)
' ========================================================================================

' CLSID = {EE09B103-97E0-11CF-978F-00A02463E06F}
$PROGID_ScriptingDictionary = "Scripting.Dictionary"
' CLSID = {32DA2B15-CFED-11D1-B747-00C04FC2B085}
$PROGID_ScriptingEncoder = "Scripting.Encoder"
' CLSID = {0D43FE01-F093-11CF-8940-00A0C9054228}
$PROGID_ScriptingFileSystemObject = "Scripting.FileSystemObject"

' ========================================================================================
' ClsIDs (Class identifiers)
' ========================================================================================

$CLSID_Drive = GUID$("{C7C3F5B1-88A3-11D0-ABCB-00A0C90FFFC0}")
$CLSID_Drives = GUID$("{C7C3F5B2-88A3-11D0-ABCB-00A0C90FFFC0}")
$CLSID_File = GUID$("{C7C3F5B5-88A3-11D0-ABCB-00A0C90FFFC0}")
$CLSID_Files = GUID$("{C7C3F5B6-88A3-11D0-ABCB-00A0C90FFFC0}")
$CLSID_Folder = GUID$("{C7C3F5B3-88A3-11D0-ABCB-00A0C90FFFC0}")
$CLSID_Folders = GUID$("{C7C3F5B4-88A3-11D0-ABCB-00A0C90FFFC0}")
$CLSID_TextStream = GUID$("{0BB02EC0-EF49-11CF-8940-00A0C9054228}")
$CLSID_Dictionary = GUID$("{EE09B103-97E0-11CF-978F-00A02463E06F}")
$CLSID_Encoder = GUID$("{32DA2B15-CFED-11D1-B747-00C04FC2B085}")
$CLSID_FileSystemObject = GUID$("{0D43FE01-F093-11CF-8940-00A0C9054228}")

' ========================================================================================
' IIDs (Interface identifiers)
' ========================================================================================

$IID_IDictionary = GUID$("{42C642C1-97E1-11CF-978F-00A02463E06F}")
$IID_IDrive = GUID$("{C7C3F5A0-88A3-11D0-ABCB-00A0C90FFFC0}")
$IID_IDriveCollection = GUID$("{C7C3F5A1-88A3-11D0-ABCB-00A0C90FFFC0}")
$IID_IFile = GUID$("{C7C3F5A4-88A3-11D0-ABCB-00A0C90FFFC0}")
$IID_IFileCollection = GUID$("{C7C3F5A5-88A3-11D0-ABCB-00A0C90FFFC0}")
$IID_IFileSystem = GUID$("{0AB5A3D0-E5B6-11D0-ABF5-00A0C90FFFC0}")
$IID_IFileSystem3 = GUID$("{2A0B9D10-4B87-11D3-A97A-00104B365C9F}")
$IID_IFolder = GUID$("{C7C3F5A2-88A3-11D0-ABCB-00A0C90FFFC0}")
$IID_IFolderCollection = GUID$("{C7C3F5A3-88A3-11D0-ABCB-00A0C90FFFC0}")
$IID_IScriptEncoder = GUID$("{AADC65F6-CFF1-11D1-B747-00C04FC2B085}")
$IID_ITextStream = GUID$("{53BAD8C1-E718-11CF-893D-00A0C9054228}")

' ========================================================================================
' CompareMethod enum
' ========================================================================================

%CompareMethod_BinaryCompare                            = 0
%CompareMethod_TextCompare                              = 1
%CompareMethod_DatabaseCompare                          = 2

' ========================================================================================
' IOMode enum
' ========================================================================================

%IOMode_ForReading                                      = 1
%IOMode_ForWriting                                      = 2
%IOMode_ForAppending                                    = 8

' ========================================================================================
' Tristate enum
' ========================================================================================

%TristateTrue                                           = -1
%TristateFalse                                          = 0
%TristateUseDefault                                     = -2
%TristateMixed                                          = -2

' ========================================================================================
' FileAttribute enum
' ========================================================================================

%FileAttribute_Normal                                   = 0
%FileAttribute_ReadOnly                                 = 1
%FileAttribute_Hidden                                   = 2
%FileAttribute_System                                   = 4
%FileAttribute_Volume                                   = 8
%FileAttribute_Directory                                = 16
%FileAttribute_Archive                                  = 32
%FileAttribute_Alias                                    = 1024
%FileAttribute_Compressed                               = 2048

' ########################################################################################
' Interface name = IDictionary
' IID = {42C642C1-97E1-11CF-978F-00A02463E06F}
' Attributes = 4176 [&H1050] [Hidden] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IDictionary_INTERFACE_DEFINED)
    %IDictionary_INTERFACE_DEFINED = 1

INTERFACE IDictionary $IID_IDictionary

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY SET putref_Item <0> ( _                     ' VTable offset = 28
     BYREF IN Key AS VARIANT _                          ' __in VARIANT* Key
   , BYREF IN pRetItem AS VARIANT _                     ' __in VARIANT* pRetItem
   )                                                    ' void
   ' =====================================================================================
   PROPERTY SET Item <0> ( _                            ' VTable offset = 32
     BYREF IN Key AS VARIANT _                          ' __in VARIANT* Key
   , BYREF IN pRetItem AS VARIANT _                     ' __in VARIANT* pRetItem
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET Item <0> ( _                            ' VTable offset = 36
     BYREF IN Key AS VARIANT _                          ' __in VARIANT* Key
   ) AS VARIANT                                         ' __retval_out VARIANT* pRetItem
   ' =====================================================================================
   METHOD Add <1> ( _                                   ' VTable offset = 40
     BYREF Key AS VARIANT _                             ' __in VARIANT* Key
   , BYREF Item AS VARIANT _                            ' __in VARIANT* Item
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET Count <2> ( _                           ' VTable offset = 44
   ) AS LONG                                            ' __retval_out long* pCount
   ' =====================================================================================
   METHOD Exists <3> ( _                                ' VTable offset = 48
     BYREF Key AS VARIANT _                             ' __in VARIANT* Key
   ) AS INTEGER                                         ' __retval_out VARIANT* pExists
   ' =====================================================================================
   METHOD Items <4> ( _                                 ' VTable offset = 52
   ) AS VARIANT                                         ' __retval_out VARIANT* pItemsArray
   ' =====================================================================================
   PROPERTY SET Key <5> ( _                             ' VTable offset = 56
     BYREF IN Key AS VARIANT _                          ' __in VARIANT *Key
   , BYREF IN rhs AS VARIANT _                          ' __in VT_VARIANT *rhs
   )                                                    ' void
   ' =====================================================================================
   METHOD Keys <6> ( _                                  ' VTable offset = 60
   ) AS VARIANT                                         ' __retval_out VT_VARIANT* pKeysArray
   ' =====================================================================================
   METHOD Remove <7> ( _                                ' VTable offset = 64
     BYREF Key AS VARIANT _                             ' __in VT_VARIANT* Key
   )                                                    ' void
   ' =====================================================================================
   METHOD RemoveAll <8> ( _                             ' VTable offset = 68
   )                                                    ' void
   ' =====================================================================================
   PROPERTY SET CompareMode <9> ( _                     ' VTable offset = 72
     BYVAL pcomp AS LONG _                              ' __in CompareMethod pcomp
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET CompareMode <9> ( _                     ' VTable offset = 76
   ) AS LONG                                            ' __retval_out CompareMethod* pcomp
   ' =====================================================================================
   METHOD NewEnum_ <-4> ( _                             ' VTable offset = 80
   ) AS IUnknown                                        ' __retval_out IUnknown** ppunk
   ' =====================================================================================
   PROPERTY GET HashVal <10> ( _                        ' VTable offset = 84
     BYREF IN Key AS VARIANT _                          ' __in VARIANT* Key
   ) AS VARIANT                                         ' __retval_out VARIANT* HashVal
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDictionary_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IFileSystem
' IID = {0AB5A3D0-E5B6-11D0-ABF5-00A0C90FFFC0}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IFileSystem_INTERFACE_DEFINED)
    %IFileSystem_INTERFACE_DEFINED = 1

INTERFACE IFileSystem $IID_IFileSystem

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Drives <10010> ( _                      ' VTable offset = 28
   ) AS IDriveCollection                                ' __retval_out IDriveCollection** ppdrives
   ' =====================================================================================
   METHOD BuildPath <10000> ( _                         ' VTable offset = 32
     BYVAL Path AS STRING _                             ' __in BSTR Path
   , BYVAL Name AS STRING _                             ' __in BSTR Name
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetDriveName <10004> ( _                      ' VTable offset = 36
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetParentFolderName <10005> ( _               ' VTable offset = 40
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetFileName <10006> ( _                       ' VTable offset = 44
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetBaseName <10007> ( _                       ' VTable offset = 48
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetExtensionName <10008> ( _                  ' VTable offset = 52
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetAbsolutePathName <10002> ( _               ' VTable offset = 56
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetTempName <10003> ( _                       ' VTable offset = 60
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD DriveExists <10015> ( _                       ' VTable offset = 64
     BYVAL DriveSpec AS STRING _                        ' __in BSTR DriveSpec
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfExists
   ' =====================================================================================
   METHOD FileExists <10016> ( _                        ' VTable offset = 68
     BYVAL FileSpec AS STRING _                         ' __in BSTR FileSpec
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfExistsVT_BOOL <Integer>
   ' =====================================================================================
   METHOD FolderExists <10017> ( _                      ' VTable offset = 72
     BYVAL FolderSpec AS STRING _                       ' __in BSTR FolderSpec
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfExists
   ' =====================================================================================
   METHOD GetDrive <10011> ( _                          ' VTable offset = 76
     BYVAL DriveSpec AS STRING _                        ' __in BSTR DriveSpec
   ) AS IDrive                                          ' __retval_out IDrive** ppdrive
   ' =====================================================================================
   METHOD GetFile <10012> ( _                           ' VTable offset = 80
     BYVAL FilePath AS STRING _                         ' __in BSTR FilePath
   ) AS IFile                                           ' __retval_out IFile** ppfile
   ' =====================================================================================
   METHOD GetFolder <10013> ( _                         ' VTable offset = 84
     BYVAL FolderPath AS STRING _                       ' __in BSTR FolderPath
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   METHOD GetSpecialFolder <10014> ( _                  ' VTable offset = 88
     BYVAL SpecialFolder AS LONG _                      ' __in SpecialFolderConst SpecialFolder
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   METHOD DeleteFile <1200> ( _                         ' VTable offset = 92
     BYVAL FileSpec AS STRING _                         ' __in BSTR FileSpec
   , OPTIONAL BYVAL Force AS INTEGER _                  ' __opt_in VARIANT_BOOL Force = 0
   )                                                    ' void
   ' =====================================================================================
   METHOD DeleteFolder <1201> ( _                       ' VTable offset = 96
     BYVAL FolderSpec AS STRING _                       ' __in BSTR FolderSpec
   , OPTIONAL BYVAL Force AS INTEGER _                  ' __in_opt VARIANT_BOOL Force = 0
   )                                                    ' void
   ' =====================================================================================
   METHOD MoveFile <1204> ( _                           ' VTable offset = 100
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   )                                                    ' void
   ' =====================================================================================
   METHOD MoveFolder <1205> ( _                         ' VTable offset = 104
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   )                                                    ' void
   ' =====================================================================================
   METHOD CopyFile <1202> ( _                           ' VTable offset = 108
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   , OPTIONAL BYVAL OverWriteFiles AS INTEGER _         ' __in_opt VARIANT_BOOL OverWriteFiles = -1
   )                                                    ' void
   ' =====================================================================================
   METHOD CopyFolder <1203> ( _                         ' VTable offset = 112
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   , OPTIONAL BYVAL OverWriteFiles AS INTEGER _         ' __in_opt VARIANT_BOOL OverWriteFiles = -1
   )                                                    ' void
   ' =====================================================================================
   METHOD CreateFolder <1120> ( _                       ' VTable offset = 116
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   METHOD CreateTextFile <1101> ( _                     ' VTable offset = 120
     BYVAL FileName AS STRING _                         ' __in BSTR FileName
   , OPTIONAL BYVAL Overwrite AS INTEGER _              ' __in_opt VARIANT_BOOL Overwrite = -1
   , OPTIONAL BYVAL Unicode AS INTEGER _                ' __in_opt VARIANT_BOOL Unicode = 0
   ) AS ITextStream                                     ' __retval_out ITextStream** ppts
   ' =====================================================================================
   METHOD OpenTextFile <1100> ( _                       ' VTable offset = 124
     BYVAL FileName AS STRING _                         ' __in BSTR FileName
   , OPTIONAL BYVAL IOMode AS LONG _                    ' __in_opt IOMode IOMode = 1
   , OPTIONAL BYVAL Create AS INTEGER _                 ' __in_opt VARIANT_BOOL Create = 0
   , OPTIONAL BYVAL Format AS LONG _                    ' __in_opt Tristate Format = 0
   ) AS ITextStream                                     ' __retval_out ITextStream** ppts
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFileSystem_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IDriveCollection
' IID = {C7C3F5A1-88A3-11D0-ABCB-00A0C90FFFC0}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IDriveCollection_INTERFACE_DEFINED)
    %IDriveCollection_INTERFACE_DEFINED = 1

INTERFACE IDriveCollection $IID_IDriveCollection

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Item <0> ( _                            ' VTable offset = 28
     BYVAL Key AS VARIANT _                             ' __in VARIANT Key
   ) AS IDrive                                          ' __retval_out IDrive** ppdrive
   ' =====================================================================================
   PROPERTY GET NewEnum_ <-4> ( _                       ' VTable offset = 32
   ) AS IUnknown                                        ' __retval_out IUnknown** ppenum
   ' =====================================================================================
   PROPERTY GET Count <1> ( _                           ' VTable offset = 36
   ) AS LONG                                            ' __retval_out long* plCount
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDriveCollection_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IDrive
' IID = {C7C3F5A0-88A3-11D0-ABCB-00A0C90FFFC0}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IDrive_INTERFACE_DEFINED)
    %IDrive_INTERFACE_DEFINED = 1

INTERFACE IDrive $IID_IDrive

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Path <0> ( _                            ' VTable offset = 28
   ) AS STRING                                          ' __retval_out BSTR* pbstrPath
   ' =====================================================================================
   PROPERTY GET DriveLetter <10000> ( _                 ' VTable offset = 32
   ) AS STRING                                          ' __retval_out BSTR* pbstrLetter
   ' =====================================================================================
   PROPERTY GET ShareName <10001> ( _                   ' VTable offset = 36
   ) AS STRING                                          ' __retval_out BSTR* pbstrShareName
   ' =====================================================================================
   PROPERTY GET DriveType <10002> ( _                   ' VTable offset = 40
   ) AS LONG                                            ' __retval_out DriveTypeConst* pdt
   ' =====================================================================================
   PROPERTY GET RootFolder <10003> ( _                  ' VTable offset = 44
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   PROPERTY GET AvailableSpace <10005> ( _              ' VTable offset = 48
   ) AS VARIANT                                         ' __retval_out VARIANT* pvarAvail
   ' =====================================================================================
   PROPERTY GET FreeSpace <10004> ( _                   ' VTable offset = 52
   ) AS VARIANT                                         ' __retval_out VARIANT* pvarFree
   ' =====================================================================================
   PROPERTY GET TotalSize <10006> ( _                   ' VTable offset = 56
   ) AS VARIANT                                         ' __retval_out VARIANT* pvarTotal
   ' =====================================================================================
   PROPERTY GET VolumeName <10007> ( _                  ' VTable offset = 60
   ) AS STRING                                          ' __retval_out BSTR* pbstrName
   ' =====================================================================================
   PROPERTY SET VolumeName <10007> ( _                  ' VTable offset = 64
     BYVAL pbstrName AS STRING _                        ' __in BSTR pbstrName
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET FileSystem <10008> ( _                  ' VTable offset = 68
   ) AS STRING                                          ' __retval_out BSTR* pbstrFileSystem
   ' =====================================================================================
   PROPERTY GET SerialNumber <10009> ( _                ' VTable offset = 72
   ) AS LONG                                            ' __retval_out long* pulSerialNumber
   ' =====================================================================================
   PROPERTY GET IsReady <10010> ( _                     ' VTable offset = 76
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfReady
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IDrive_INTERFACE_DEFINED__ */

' ========================================================================================
' DriveTypeConst enum
' ========================================================================================

%DriveType_UnknownType                                  = 0
%DriveType_Removable                                    = 1
%DriveType_Fixed                                        = 2
%DriveType_Remote                                       = 3
%DriveType_CDRom                                        = 4
%DriveType_RamDisk                                      = 5

' ########################################################################################
' Interface name = IFolder
' IID = {C7C3F5A2-88A3-11D0-ABCB-00A0C90FFFC0}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IFolder_INTERFACE_DEFINED)
    %IFolder_INTERFACE_DEFINED = 1

INTERFACE IFolder $IID_IFolder

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Path <0> ( _                            ' VTable offset = 28
   ) AS STRING                                          ' __retval_out BSTR* pbstrPath
   ' =====================================================================================
   PROPERTY GET Name <1000> ( _                         ' VTable offset = 32
   ) AS STRING                                          ' __retval_out BSTR* pbstrName
   ' =====================================================================================
   PROPERTY SET Name <1000> ( _                         ' VTable offset = 36
     BYVAL pbstrName AS STRING _                        ' __in BSTR pbstrName
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET ShortPath <1002> ( _                    ' VTable offset = 40
   ) AS STRING                                          ' __retval_out BSTR* pbstrPath
   ' =====================================================================================
   PROPERTY GET ShortName <1001> ( _                    ' VTable offset = 44
   ) AS STRING                                          ' __retval_out BSTR* pbstrName
   ' =====================================================================================
   PROPERTY GET Drive <1004> ( _                        ' VTable offset = 48
   ) AS IDrive                                          ' __retval_out IDrive** ppdrive
   ' =====================================================================================
   PROPERTY GET ParentFolder <1005> ( _                 ' VTable offset = 52
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   PROPERTY GET Attributes <1003> ( _                   ' VTable offset = 56
   ) AS LONG                                            ' __retval_out FileAttribute* pfa
   ' =====================================================================================
   PROPERTY SET Attributes <1003> ( _                   ' VTable offset = 60
     BYVAL pfa AS LONG _                                ' __in FileAttribute pfa
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET DateCreated <1006> ( _                  ' VTable offset = 64
   ) AS DOUBLE                                          ' __retval_out DATE* pdate
   ' =====================================================================================
   PROPERTY GET DateLastModified <1007> ( _             ' VTable offset = 68
   ) AS DOUBLE                                          ' __retval_out DATE* pdate
   ' =====================================================================================
   PROPERTY GET DateLastAccessed <1008> ( _             ' VTable offset = 72
   ) AS DOUBLE                                          ' __retval_out DATE* pdate
   ' =====================================================================================
   PROPERTY GET Type <1010> ( _                         ' VTable offset = 76
   ) AS STRING                                          ' __retval_out BSTR* pbstrType
   ' =====================================================================================
   METHOD Delete <1201> ( _                             ' VTable offset = 80
     OPTIONAL BYVAL Force AS INTEGER _                  ' __in_opt VARIANT_BOOL Force = 0
   )                                                    ' void
   ' =====================================================================================
   METHOD Copy <1203> ( _                               ' VTable offset = 84
     BYVAL Destination AS STRING _                      ' __in BSTR Destination
   , OPTIONAL BYVAL OverWriteFiles AS INTEGER _         ' __in_opt VARIANT_BOOL OverWriteFiles = -1
   )                                                    ' void
   ' =====================================================================================
   METHOD Move <1205> ( _                               ' VTable offset = 88
     BYVAL Destination AS STRING _                      ' __in BSTR Destination
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET IsRootFolder <10000> ( _                ' VTable offset = 92
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfRootFolder
   ' =====================================================================================
   PROPERTY GET Size <1009> ( _                         ' VTable offset = 96
   ) AS VARIANT                                         ' __retval_out VARIANT* pvarSize
   ' =====================================================================================
   PROPERTY GET SubFolders <10001> ( _                  ' VTable offset = 100
   ) AS IFolderCollection                               ' __retval_out IFolderCollection** ppfolders
   ' =====================================================================================
   PROPERTY GET Files <10002> ( _                       ' VTable offset = 104
   ) AS IFileCollection                                 ' __retval_out IFileCollection** ppfiles
   ' =====================================================================================
   METHOD CreateTextFile <1101> ( _                     ' VTable offset = 108
     BYVAL FileName AS STRING _                         ' __in BSTR FileName
   , OPTIONAL BYVAL Overwrite AS INTEGER _              ' __in_opt VARIANT_BOOL Overwrite = -1
   , OPTIONAL BYVAL Unicode AS INTEGER _                ' __in_opt VARIANT_BOOL Unicode = 0
   ) AS ITextStream                                     ' __retval_out ITextStream** ppts
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFolder_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IFolderCollection
' IID = {C7C3F5A3-88A3-11D0-ABCB-00A0C90FFFC0}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IFolderCollection_INTERFACE_DEFINED)
    %IFolderCollection_INTERFACE_DEFINED = 1

INTERFACE IFolderCollection $IID_IFolderCollection

   INHERIT IDispatch

   ' =====================================================================================
   METHOD Add <2> ( _                                   ' VTable offset = 28
     BYVAL Name AS STRING _                             ' __in BSTR Name
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   PROPERTY GET Item <0> ( _                            ' VTable offset = 32
     BYVAL Key AS VARIANT _                             ' __in VARIANT Key
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   PROPERTY GET NewEnum_ <-4> ( _                       ' VTable offset = 36
   ) AS IUnknown                                        ' __retval_out IUnknown** ppenum
   ' =====================================================================================
   PROPERTY GET Count <1> ( _                           ' VTable offset = 40
   ) AS LONG                                            ' __retval_out long* plCount
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFolderCollection_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IFileCollection
' IID = {C7C3F5A5-88A3-11D0-ABCB-00A0C90FFFC0}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IFileCollection_INTERFACE_DEFINED)
    %IFileCollection_INTERFACE_DEFINED = 1

INTERFACE IFileCollection $IID_IFileCollection

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Item <0> ( _                            ' VTable offset = 28
     BYVAL Key AS VARIANT _                             ' __in VARIANT Key
   ) AS IFile                                           ' __retval_out IFile** ppfile
   ' =====================================================================================
   PROPERTY GET NewEnum_ <-4> ( _                       ' VTable offset = 32
   ) AS IUnknown                                        ' __retval_out IUnknown** ppenum
   ' =====================================================================================
   PROPERTY GET Count <1> ( _                           ' VTable offset = 36
   ) AS LONG                                            ' __retval_out long* plCount
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFileCollection_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IFile
' IID = {C7C3F5A4-88A3-11D0-ABCB-00A0C90FFFC0}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IFile_INTERFACE_DEFINED)
    %IFile_INTERFACE_DEFINED = 1

INTERFACE IFile $IID_IFile

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Path <0> ( _                            ' VTable offset = 28
   ) AS STRING                                          ' __retval_out BSTR* pbstrPath
   ' =====================================================================================
   PROPERTY GET Name <1000> ( _                         ' VTable offset = 32
   ) AS STRING                                          ' __retval_out BSTR* pbstrName
   ' =====================================================================================
   PROPERTY SET Name <1000> ( _                         ' VTable offset = 36
     BYVAL pbstrName AS STRING _                        ' __in BSTR pbstrName
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET ShortPath <1002> ( _                    ' VTable offset = 40
   ) AS STRING                                          ' __retval_out BSTR* pbstrPath
   ' =====================================================================================
   PROPERTY GET ShortName <1001> ( _                    ' VTable offset = 44
   ) AS STRING                                          ' __retval_out BSTR* pbstrName
   ' =====================================================================================
   PROPERTY GET Drive <1004> ( _                        ' VTable offset = 48
   ) AS IDrive                                          ' __retval_out IDrive** ppdrive
   ' =====================================================================================
   PROPERTY GET ParentFolder <1005> ( _                 ' VTable offset = 52
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   PROPERTY GET Attributes <1003> ( _                   ' VTable offset = 56
   ) AS LONG                                            ' __retval_out FileAttribute* pfa
   ' =====================================================================================
   PROPERTY SET Attributes <1003> ( _                   ' VTable offset = 60
     BYVAL pfa AS LONG _                                ' __in FileAttribute pfa
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET DateCreated <1006> ( _                  ' VTable offset = 64
   ) AS DOUBLE                                          ' __retval_out DATE* pdate
   ' =====================================================================================
   PROPERTY GET DateLastModified <1007> ( _             ' VTable offset = 68
   ) AS DOUBLE                                          ' __retval_out DATE* pdate
   ' =====================================================================================
   PROPERTY GET DateLastAccessed <1008> ( _             ' VTable offset = 72
   ) AS DOUBLE                                          ' __retval_out DATE* pdate
   ' =====================================================================================
   PROPERTY GET Size <1009> ( _                         ' VTable offset = 76
   ) AS VARIANT                                         ' __retval_out VARIANT* pvarSize
   ' =====================================================================================
   PROPERTY GET Type <1010> ( _                         ' VTable offset = 80
   ) AS STRING                                          ' __retval_out BSTR* pbstrType
   ' =====================================================================================
   METHOD Delete <1200> ( _                             ' VTable offset = 84
     OPTIONAL BYVAL Force AS INTEGER _                  ' __in_opt VARIANT_BOOL Force = 0
   )                                                    ' void
   ' =====================================================================================
   METHOD Copy <1202> ( _                               ' VTable offset = 88
     BYVAL Destination AS STRING _                      ' __in BSTR Destination
   , OPTIONAL BYVAL OverWriteFiles AS INTEGER _         ' __in_opt VARIANT_BOOL OverWriteFiles = -1
   )                                                    ' void
   ' =====================================================================================
   METHOD Move <1204> ( _                               ' VTable offset = 92
     BYVAL Destination AS STRING _                      ' __in BSTR Destination
   )                                                    ' void
   ' =====================================================================================
   METHOD OpenAsTextStream <1100> ( _                   ' VTable offset = 96
     OPTIONAL BYVAL IOMode AS LONG _                    ' __in_opt IOMode IOMode = 1
   , OPTIONAL BYVAL Format AS LONG _                    ' __in_opt Tristate Format = 0
   ) AS ITextStream                                     ' __retval_out ITextStream** ppts
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFile_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = ITextStream
' IID = {53BAD8C1-E718-11CF-893D-00A0C9054228}
' Attributes = 4304 [&H10D0] [Hidden] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%ITextStream_INTERFACE_DEFINED)
    %ITextStream_INTERFACE_DEFINED = 1

INTERFACE ITextStream $IID_ITextStream

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Line <10000> ( _                        ' VTable offset = 28
   ) AS LONG                                            ' __retval_out long* Line
   ' =====================================================================================
   PROPERTY GET Column <-529> ( _                       ' VTable offset = 32
   ) AS LONG                                            ' __retval_out long* Column
   ' =====================================================================================
   PROPERTY GET AtEndOfStream <10002> ( _               ' VTable offset = 36
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* EOS
   ' =====================================================================================
   PROPERTY GET AtEndOfLine <10003> ( _                 ' VTable offset = 40
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* EOL
   ' =====================================================================================
   METHOD Read <10004> ( _                              ' VTable offset = 44
     BYVAL Characters AS LONG _                         ' __in long Characters
   ) AS STRING                                          ' __retval_out BSTR* Text
   ' =====================================================================================
   METHOD ReadLine <10005> ( _                          ' VTable offset = 48
   ) AS STRING                                          ' __retval_out BSTR* Text
   ' =====================================================================================
   METHOD ReadAll <10006> ( _                           ' VTable offset = 52
   ) AS STRING                                          ' __retval_out BSTR* Text
   ' =====================================================================================
   METHOD Write <10007> ( _                             ' VTable offset = 56
     BYVAL Text AS STRING _                             ' __in BSTR Text
   )                                                    ' void
   ' =====================================================================================
   METHOD WriteLine <10008> ( _                         ' VTable offset = 60
     OPTIONAL BYVAL Text AS STRING _                    ' __in_opt BSTR Text = L""
   )                                                    ' void
   ' =====================================================================================
   METHOD WriteBlankLines <10009> ( _                   ' VTable offset = 64
     BYVAL Lines AS LONG _                              ' __in long Lines
   )                                                    ' void
   ' =====================================================================================
   METHOD Skip <10010> ( _                              ' VTable offset = 68
     BYVAL Characters AS LONG _                         ' __in long Characters
   )                                                    ' void
   ' =====================================================================================
   METHOD SkipLine <10011> ( _                          ' VTable offset = 72
   )                                                    ' void
   ' =====================================================================================
   METHOD Close <10012> ( _                             ' VTable offset = 76
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __ITextStream_INTERFACE_DEFINED__ */

' ========================================================================================
' SpecialFolderConst enum
' ========================================================================================

%SpecialFolder_WindowsFolder                            = 0
%SpecialFolder_SystemFolder                             = 1
%SpecialFolder_TemporaryFolder                          = 2

' ########################################################################################
' Interface name = IFileSystem3
' IID = {2A0B9D10-4B87-11D3-A97A-00104B365C9F}
' Attributes = 4288 [&H10C0] [Dual] [Nonextensible] [Dispatchable]
' Inherited interface = IFileSystem
' ########################################################################################

#IF NOT %DEF(%IFileSystem3_INTERFACE_DEFINED)
    %IFileSystem3_INTERFACE_DEFINED = 1

INTERFACE IFileSystem3 $IID_IFileSystem3

   INHERIT IDispatch

   ' =====================================================================================
   ' IFileSystem Methods
   ' =====================================================================================
   PROPERTY GET Drives <10010> ( _                      ' VTable offset = 28
   ) AS IDriveCollection                                ' __retval_out IDriveCollection** ppdrives
   ' =====================================================================================
   METHOD BuildPath <10000> ( _                         ' VTable offset = 32
     BYVAL Path AS STRING _                             ' __in BSTR Path
   , BYVAL Name AS STRING _                             ' __in BSTR Name
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetDriveName <10004> ( _                      ' VTable offset = 36
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetParentFolderName <10005> ( _               ' VTable offset = 40
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetFileName <10006> ( _                       ' VTable offset = 44
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetBaseName <10007> ( _                       ' VTable offset = 48
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetExtensionName <10008> ( _                  ' VTable offset = 52
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetAbsolutePathName <10002> ( _               ' VTable offset = 56
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD GetTempName <10003> ( _                       ' VTable offset = 60
   ) AS STRING                                          ' __retval_out BSTR* pbstrResult
   ' =====================================================================================
   METHOD DriveExists <10015> ( _                       ' VTable offset = 64
     BYVAL DriveSpec AS STRING _                        ' __in BSTR DriveSpec
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfExists
   ' =====================================================================================
   METHOD FileExists <10016> ( _                        ' VTable offset = 68
     BYVAL FileSpec AS STRING _                         ' __in BSTR FileSpec
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfExistsVT_BOOL <Integer>
   ' =====================================================================================
   METHOD FolderExists <10017> ( _                      ' VTable offset = 72
     BYVAL FolderSpec AS STRING _                       ' __in BSTR FolderSpec
   ) AS INTEGER                                         ' __retval_out VARIANT_BOOL* pfExists
   ' =====================================================================================
   METHOD GetDrive <10011> ( _                          ' VTable offset = 76
     BYVAL DriveSpec AS STRING _                        ' __in BSTR DriveSpec
   ) AS IDrive                                          ' __retval_out IDrive** ppdrive
   ' =====================================================================================
   METHOD GetFile <10012> ( _                           ' VTable offset = 80
     BYVAL FilePath AS STRING _                         ' __in BSTR FilePath
   ) AS IFile                                           ' __retval_out IFile** ppfile
   ' =====================================================================================
   METHOD GetFolder <10013> ( _                         ' VTable offset = 84
     BYVAL FolderPath AS STRING _                       ' __in BSTR FolderPath
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   METHOD GetSpecialFolder <10014> ( _                  ' VTable offset = 88
     BYVAL SpecialFolder AS LONG _                      ' __in SpecialFolderConst SpecialFolder
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   METHOD DeleteFile <1200> ( _                         ' VTable offset = 92
     BYVAL FileSpec AS STRING _                         ' __in BSTR FileSpec
   , OPTIONAL BYVAL Force AS INTEGER _                  ' __opt_in VARIANT_BOOL Force = 0
   )                                                    ' void
   ' =====================================================================================
   METHOD DeleteFolder <1201> ( _                       ' VTable offset = 96
     BYVAL FolderSpec AS STRING _                       ' __in BSTR FolderSpec
   , OPTIONAL BYVAL Force AS INTEGER _                  ' __in_opt VARIANT_BOOL Force = 0
   )                                                    ' void
   ' =====================================================================================
   METHOD MoveFile <1204> ( _                           ' VTable offset = 100
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   )                                                    ' void
   ' =====================================================================================
   METHOD MoveFolder <1205> ( _                         ' VTable offset = 104
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   )                                                    ' void
   ' =====================================================================================
   METHOD CopyFile <1202> ( _                           ' VTable offset = 108
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   , OPTIONAL BYVAL OverWriteFiles AS INTEGER _         ' __in_opt VARIANT_BOOL OverWriteFiles = -1
   )                                                    ' void
   ' =====================================================================================
   METHOD CopyFolder <1203> ( _                         ' VTable offset = 112
     BYVAL Source AS STRING _                           ' __in BSTR Source
   , BYVAL Destination AS STRING _                      ' __in BSTR Destination
   , OPTIONAL BYVAL OverWriteFiles AS INTEGER _         ' __in_opt VARIANT_BOOL OverWriteFiles = -1
   )                                                    ' void
   ' =====================================================================================
   METHOD CreateFolder <1120> ( _                       ' VTable offset = 116
     BYVAL Path AS STRING _                             ' __in BSTR Path
   ) AS IFolder                                         ' __retval_out IFolder** ppfolder
   ' =====================================================================================
   METHOD CreateTextFile <1101> ( _                     ' VTable offset = 120
     BYVAL FileName AS STRING _                         ' __in BSTR FileName
   , OPTIONAL BYVAL Overwrite AS INTEGER _              ' __in_opt VARIANT_BOOL Overwrite = -1
   , OPTIONAL BYVAL Unicode AS INTEGER _                ' __in_opt VARIANT_BOOL Unicode = 0
   ) AS ITextStream                                     ' __retval_out ITextStream** ppts
   ' =====================================================================================
   METHOD OpenTextFile <1100> ( _                       ' VTable offset = 124
     BYVAL FileName AS STRING _                         ' __in BSTR FileName
   , OPTIONAL BYVAL IOMode AS LONG _                    ' __in_opt IOMode IOMode = 1
   , OPTIONAL BYVAL Create AS INTEGER _                 ' __in_opt VARIANT_BOOL Create = 0
   , OPTIONAL BYVAL Format AS LONG _                    ' __in_opt Tristate Format = 0
   ) AS ITextStream                                     ' __retval_out ITextStream** ppts
   ' =====================================================================================

   ' =====================================================================================
   ' IFileSystem3 Methods
   ' =====================================================================================
   METHOD GetStandardStream <20000> ( _                 ' VTable offset = 128
     BYVAL StandardStreamType AS LONG _                 ' __in StandardStreamTypes StandardStreamType
   , OPTIONAL BYVAL Unicode AS INTEGER _                ' __in_opt VARIANT_BOOL Unicode = 0
   ) AS ITextStream                                     ' __retval_out ITextStream** ppts
   ' =====================================================================================
   METHOD GetFileVersion <20010> ( _                    ' VTable offset = 132
     BYVAL FileName AS STRING _                         ' __in BSTR FileName
   ) AS STRING                                          ' __retval_out BSTR* FileVersion
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IFileSystem3_INTERFACE_DEFINED__ */

' ========================================================================================
' StandardStreamTypes enum
' ========================================================================================

%StreamType_StdIn                                       = 0
%StreamType_StdOut                                      = 1
%StreamType_StdErr                                      = 2

' ########################################################################################
' Interface name = IScriptEncoder
' IID = {AADC65F6-CFF1-11D1-B747-00C04FC2B085}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IScriptEncoder_INTERFACE_DEFINED)
    %IScriptEncoder_INTERFACE_DEFINED = 1

INTERFACE IScriptEncoder $IID_IScriptEncoder

   INHERIT IDispatch

   ' =====================================================================================
   METHOD EncodeScriptFile <0> ( _                      ' VTable offset = 28
     BYVAL szExt AS STRING _                            ' __in BSTR szExt
   , BYVAL bstrStreamIn AS STRING _                     ' __in BSTR bstrStreamIn
   , BYVAL cFlags AS LONG _                             ' __in long cFlags
   , BYVAL bstrDefaultLang AS STRING _                  ' __in BSTR bstrDefaultLang
   ) AS STRING                                          ' __retval_out BSTR* pbstrStreamOut
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IScriptEncoder_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%SCRRUN_INC)

'/////////////////////////////////////////////////////////////////////////////////////////

' ========================================================================================
' ProgIDs (Program identifiers)
' ========================================================================================

' CLSID = {093FF999-1EA0-4079-9525-9614C3504B74}
$PROGID_WScriptNetwork1 = "WScript.Network.1"
' CLSID = {72C24DD5-D70A-438B-8A42-98424B88AFB8}
$PROGID_WScriptShell1 = "WScript.Shell.1"

' ========================================================================================
' Version independent ProgIDs
' ========================================================================================

' CLSID = {F935DC26-1CF0-11D0-ADB9-00C04FD58A0B}
$PROGID_WScriptNetwork = "WScript.Network"
' CLSID = {F935DC22-1CF0-11D0-ADB9-00C04FD58A0B}
$PROGID_WScriptShell = "WScript.Shell"

' ========================================================================================
' ClsIDs (Class identifiers)
' ========================================================================================

$CLSID_IWshCollection_Class  = GUID$("{F935DC28-1CF0-11D0-ADB9-00C04FD58A0B}")
$CLSID_IWshEnvironment_Class = GUID$("{F935DC2A-1CF0-11D0-ADB9-00C04FD58A0B}")
$CLSID_IWshNetwork_Class     = GUID$("{F935DC26-1CF0-11D0-ADB9-00C04FD58A0B}")
$CLSID_IWshShell_Class       = GUID$("{F935DC22-1CF0-11D0-ADB9-00C04FD58A0B}")
$CLSID_IWshShortcut_Class    = GUID$("{F935DC24-1CF0-11D0-ADB9-00C04FD58A0B}")
$CLSID_IWshURLShortcut_Class = GUID$("{F935DC2C-1CF0-11D0-ADB9-00C04FD58A0B}")
$CLSID_WshCollection         = GUID$("{387DAFF4-DA03-44D2-B0D1-80C927C905AC}")
$CLSID_WshEnvironment        = GUID$("{F48229AF-E28C-42B5-BB92-E114E62BDD54}")
$CLSID_WshExec               = GUID$("{08FED191-BE19-11D3-A28B-00104BD35090}")
$CLSID_WshShortcut           = GUID$("{A548B8E4-51D5-4661-8824-DAA1D893DFB2}")
$CLSID_WshURLShortcut        = GUID$("{50E13488-6F1E-4450-96B0-873755403955}")
$CLSID_WshNetwork            = GUID$("{093FF999-1EA0-4079-9525-9614C3504B74}")
$CLSID_WshShell              = GUID$("{72C24DD5-D70A-438B-8A42-98424B88AFB8}")

' ========================================================================================
' IIDs (Interface identifiers)
' ========================================================================================

$IID_IWshCollection          = GUID$("{F935DC27-1CF0-11D0-ADB9-00C04FD58A0B}")
$IID_IWshEnvironment         = GUID$("{F935DC29-1CF0-11D0-ADB9-00C04FD58A0B}")
$IID_IWshExec                = GUID$("{08FED190-BE19-11D3-A28B-00104BD35090}")
$IID_IWshNetwork             = GUID$("{F935DC25-1CF0-11D0-ADB9-00C04FD58A0B}")
$IID_IWshNetwork2            = GUID$("{24BE5A31-EDFE-11D2-B933-00104B365C9F}")
$IID_IWshShell               = GUID$("{F935DC21-1CF0-11D0-ADB9-00C04FD58A0B}")
$IID_IWshShell2              = GUID$("{24BE5A30-EDFE-11D2-B933-00104B365C9F}")
$IID_IWshShell3              = GUID$("{41904400-BE18-11D3-A28B-00104BD35090}")
$IID_IWshShortcut            = GUID$("{F935DC23-1CF0-11D0-ADB9-00C04FD58A0B}")
$IID_IWshURLShortcut         = GUID$("{F935DC2B-1CF0-11D0-ADB9-00C04FD58A0B}")

' ========================================================================================
' WshExecStatus enum
' ========================================================================================

%WshRunning                                             = 0            ' &H0
%WshFinished                                            = 1            ' &H1
%WshFailed                                              = 2            ' &H2

' ========================================================================================
' WshWindowStyle enum
' ========================================================================================

%WshHide                                                = 0            ' &H0
%WshNormalFocus                                         = 1            ' &H1
%WshMinimizedFocus                                      = 2            ' &H2
%WshMaximizedFocus                                      = 3            ' &H3
%WshNormalNoFocus                                       = 4            ' &H4
%WshMinimizedNoFocus                                    = 6            ' &H6

' ########################################################################################
' Interface name = IWshShell
' IID = {F935DC21-1CF0-11D0-ADB9-00C04FD58A0B}
' Attributes = 4176 [&H1050] [Hidden] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IWshShell_INTERFACE_DEFINED)
    %IWshShell_INTERFACE_DEFINED = 1

INTERFACE IWshShell $IID_IWshShell

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET SpecialFolders <100> ( _                ' VTable offset = 28
   ) AS IWshCollection                                  ' __out_retval IWshCollection** out_Folders
   ' =====================================================================================
   PROPERTY GET Environment <200> ( _                   ' VTable offset = 32
     OPTIONAL BYREF IN Type AS VARIANT _                ' __in_opt VARIANT* Type
   ) AS IWshEnvironment                                 ' __out_retval IWshEnvironment** out_Env
   ' =====================================================================================
   METHOD Run <1000> ( _                                ' VTable offset = 36
     BYVAL Command AS STRING _                          ' __in BSTR Command
   , OPTIONAL BYREF Command AS VARIANT _                ' __in_opt VARIANT* WindowStyle
   , OPTIONAL BYREF WaitOnReturn AS VARIANT _           ' __in_opt VARIANT* WaitOnReturn
   ) AS LONG                                            ' __out_retval int* out_ExitCode
   ' =====================================================================================
   METHOD Popup <1001> ( _                              ' VTable offset = 40
     BYVAL Text AS STRING _                             ' __in BSTR Text
   , OPTIONAL BYREF SecondsToWait AS VARIANT _          ' __in_opt VARIANT* SecondsToWait
   , OPTIONAL BYREF Title AS VARIANT _                  ' __in_opt VARIANT* Title
   , OPTIONAL BYREF Type AS VARIANT _                   ' __in_opt VARIANT* Type
   ) AS LONG                                            ' __out_retval int* out_Button
   ' =====================================================================================
   METHOD CreateShortcut <1002> ( _                     ' VTable offset = 44
     BYVAL PathLink AS STRING _                         ' __in BSTR PathLink
   ) AS IDispatch                                       ' __out_retval IDispatch** out_Shortcut
   ' =====================================================================================
   METHOD ExpandEnvironmentStrings <1006> ( _           ' VTable offset = 48
     BYVAL Src AS STRING _                              ' __in BSTR Src
   ) AS STRING                                          ' __out_retval BSTR* out_Dst);
   ' =====================================================================================
   METHOD RegRead <2000> ( _                            ' VTable offset = 52
     BYVAL Name AS STRING _                             ' __in BSTR Name
   ) AS VARIANT                                         ' __out_retval VARIANT* out_Value
   ' =====================================================================================
   METHOD RegWrite <2001> ( _                           ' VTable offset = 56
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , BYREF Value AS VARIANT _                           ' __in VARIANT* Value
   , OPTIONAL BYREF Type AS VARIANT _                   ' __in_opt VARIANT* Type
   )                                                    ' void
   ' =====================================================================================
   METHOD RegDelete <2002> ( _                          ' VTable offset = 60
     BYVAL Name AS STRING _                             ' __in BSTR Name
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshShell_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshCollection
' IID = {F935DC27-1CF0-11D0-ADB9-00C04FD58A0B}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IWshCollection_INTERFACE_DEFINED)
    %IWshCollection_INTERFACE_DEFINED = 1

INTERFACE IWshCollection $IID_IWshCollection

   INHERIT IDispatch

   ' =====================================================================================
   METHOD Item <0> ( _                                  ' VTable offset = 28
     BYREF Index AS VARIANT _                           ' __in VARIANT* Index
   ) AS VARIANT                                         ' __out_retval VARIANT* out_Value
   ' =====================================================================================
   METHOD Count <1> ( _                                 ' VTable offset = 32
   ) AS LONG                                            ' __out_retval long* out_Count
   ' =====================================================================================
   PROPERTY GET length <2> ( _                          ' VTable offset = 36
   ) AS LONG                                            ' __out_retval long* out_Count
   ' =====================================================================================
   METHOD NewEnum_ <-4> ( _                             ' VTable offset = 40
   ) AS IUnknown                                        ' __out_retval IUnknown** out_Enum
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshCollection_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshEnvironment
' IID = {F935DC29-1CF0-11D0-ADB9-00C04FD58A0B}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IWshEnvironment_INTERFACE_DEFINED)
    %IWshEnvironment_INTERFACE_DEFINED = 1

INTERFACE IWshEnvironment $IID_IWshEnvironment

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Item <0> ( _                            ' VTable offset = 28
     BYVAL Name AS STRING _                             ' __in BSTR Name
   ) AS STRING                                          ' __out_retval BSTR* out_Value
   ' =====================================================================================
   PROPERTY SET Item <0> ( _                            ' VTable offset = 32
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , BYVAL out_Value AS STRING _                        ' __in BSTR out_Value
   )                                                    ' void
   ' =====================================================================================
   METHOD Count <1> ( _                                 ' VTable offset = 36
   ) AS LONG                                            ' __out_retval long* out_Count
   ' =====================================================================================
   PROPERTY GET length <2> ( _                          ' VTable offset = 40
   ) AS LONG                                            ' __out_retval long* out_Count
   ' =====================================================================================
   METHOD NewEnum_ <-4> ( _                             ' VTable offset = 44
   ) AS IUnknown                                        ' __out_retval IUnknown** out_Enum
   ' =====================================================================================
   METHOD Remove <1001> ( _                             ' VTable offset = 48
     BYVAL Name AS STRING _                             ' __in BSTR Name
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshEnvironment_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshShell2
' IID = {24BE5A30-EDFE-11D2-B933-00104B365C9F}
' Attributes = 4176 [&H1050] [Hidden] [Dual] [Dispatchable]
' Inherited interface = IWshShell
' ########################################################################################

#IF NOT %DEF(%IWshShell2_INTERFACE_DEFINED)
    %IWshShell2_INTERFACE_DEFINED = 1

INTERFACE IWshShell2 $IID_IWshShell2

   INHERIT IDispatch

   ' =====================================================================================
   ' IWshShell Methods
   ' =====================================================================================
   PROPERTY GET SpecialFolders <100> ( _                ' VTable offset = 28
   ) AS IWshCollection                                  ' __out_retval IWshCollection** out_Folders
   ' =====================================================================================
   PROPERTY GET Environment <200> ( _                   ' VTable offset = 32
     OPTIONAL BYREF IN Type AS VARIANT _                ' __in_opt VARIANT* Type
   ) AS IWshEnvironment                                 ' __out_retval IWshEnvironment** out_Env
   ' =====================================================================================
   METHOD Run <1000> ( _                                ' VTable offset = 36
     BYVAL Command AS STRING _                          ' __in BSTR Command
   , OPTIONAL BYREF Command AS VARIANT _                ' __in_opt VARIANT* WindowStyle
   , OPTIONAL BYREF WaitOnReturn AS VARIANT _           ' __in_opt VARIANT* WaitOnReturn
   ) AS LONG                                            ' __out_retval int* out_ExitCode
   ' =====================================================================================
   METHOD Popup <1001> ( _                              ' VTable offset = 40
     BYVAL Text AS STRING _                             ' __in BSTR Text
   , OPTIONAL BYREF SecondsToWait AS VARIANT _          ' __in_opt VARIANT* SecondsToWait
   , OPTIONAL BYREF Title AS VARIANT _                  ' __in_opt VARIANT* Title
   , OPTIONAL BYREF Type AS VARIANT _                   ' __in_opt VARIANT* Type
   ) AS LONG                                            ' __out_retval int* out_Button
   ' =====================================================================================
   METHOD CreateShortcut <1002> ( _                     ' VTable offset = 44
     BYVAL PathLink AS STRING _                         ' __in BSTR PathLink
   ) AS IDispatch                                       ' __out_retval IDispatch** out_Shortcut
   ' =====================================================================================
   METHOD ExpandEnvironmentStrings <1006> ( _           ' VTable offset = 48
     BYVAL Src AS STRING _                              ' __in BSTR Src
   ) AS STRING                                          ' __out_retval BSTR* out_Dst);
   ' =====================================================================================
   METHOD RegRead <2000> ( _                            ' VTable offset = 52
     BYVAL Name AS STRING _                             ' __in BSTR Name
   ) AS VARIANT                                         ' __out_retval VARIANT* out_Value
   ' =====================================================================================
   METHOD RegWrite <2001> ( _                           ' VTable offset = 56
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , BYREF Value AS VARIANT _                           ' __in VARIANT* Value
   , OPTIONAL BYREF Type AS VARIANT _                   ' __in_opt VARIANT* Type
   )                                                    ' void
   ' =====================================================================================
   METHOD RegDelete <2002> ( _                          ' VTable offset = 60
     BYVAL Name AS STRING _                             ' __in BSTR Name
   )                                                    ' void
   ' =====================================================================================

   ' =====================================================================================
   ' IWshShell2 Methods
   ' =====================================================================================
   METHOD LogEvent <3000> ( _                           ' VTable offset = 64
     BYREF Type AS VARIANT _                            ' __in VARIANT* Type
   , BYVAL Message AS STRING _                          ' __in BSTR Message
   , OPTIONAL BYVAL Target AS STRING _                  ' __in_opt BSTR Target = L""
   ) AS INTEGER                                         ' __out_retval VARIANT_BOOL* out_Success
   ' =====================================================================================
   METHOD AppActivate <3010> ( _                        ' VTable offset = 68
     BYREF App AS VARIANT _                             ' __in VARIANT* App
   , OPTIONAL BYREF Wait AS VARIANT _                   ' __in_opt VARIANT* Wait
   ) AS INTEGER                                         ' __out_retval VARIANT_BOOL* out_Success
   ' =====================================================================================
   METHOD SendKeys <3011> ( _                           ' VTable offset = 72
     BYVAL Keys AS STRING _                             ' __in BSTR Keys
   , OPTIONAL BYREF Wait AS VARIANT _                   ' __in_opt VARIANT* Wait
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshShell2_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshShell3
' IID = {41904400-BE18-11D3-A28B-00104BD35090}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IWshShell2
' ########################################################################################

#IF NOT %DEF(%IWshShell3_INTERFACE_DEFINED)
    %IWshShell3_INTERFACE_DEFINED = 1

INTERFACE IWshShell3 $IID_IWshShell3

   INHERIT IDispatch

   ' =====================================================================================
   ' IWshShell Methods
   ' =====================================================================================
   PROPERTY GET SpecialFolders <100> ( _                ' VTable offset = 28
   ) AS IWshCollection                                  ' __out_retval IWshCollection** out_Folders
   ' =====================================================================================
   PROPERTY GET Environment <200> ( _                   ' VTable offset = 32
     OPTIONAL BYREF IN Type AS VARIANT _                ' __in_opt VARIANT* Type
   ) AS IWshEnvironment                                 ' __out_retval IWshEnvironment** out_Env
   ' =====================================================================================
   METHOD Run <1000> ( _                                ' VTable offset = 36
     BYVAL Command AS STRING _                          ' __in BSTR Command
   , OPTIONAL BYREF Command AS VARIANT _                ' __in_opt VARIANT* WindowStyle
   , OPTIONAL BYREF WaitOnReturn AS VARIANT _           ' __in_opt VARIANT* WaitOnReturn
   ) AS LONG                                            ' __out_retval int* out_ExitCode
   ' =====================================================================================
   METHOD Popup <1001> ( _                              ' VTable offset = 40
     BYVAL Text AS STRING _                             ' __in BSTR Text
   , OPTIONAL BYREF SecondsToWait AS VARIANT _          ' __in_opt VARIANT* SecondsToWait
   , OPTIONAL BYREF Title AS VARIANT _                  ' __in_opt VARIANT* Title
   , OPTIONAL BYREF Type AS VARIANT _                   ' __in_opt VARIANT* Type
   ) AS LONG                                            ' __out_retval int* out_Button
   ' =====================================================================================
   METHOD CreateShortcut <1002> ( _                     ' VTable offset = 44
     BYVAL PathLink AS STRING _                         ' __in BSTR PathLink
   ) AS IDispatch                                       ' __out_retval IDispatch** out_Shortcut
   ' =====================================================================================
   METHOD ExpandEnvironmentStrings <1006> ( _           ' VTable offset = 48
     BYVAL Src AS STRING _                              ' __in BSTR Src
   ) AS STRING                                          ' __out_retval BSTR* out_Dst);
   ' =====================================================================================
   METHOD RegRead <2000> ( _                            ' VTable offset = 52
     BYVAL Name AS STRING _                             ' __in BSTR Name
   ) AS VARIANT                                         ' __out_retval VARIANT* out_Value
   ' =====================================================================================
   METHOD RegWrite <2001> ( _                           ' VTable offset = 56
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , BYREF Value AS VARIANT _                           ' __in VARIANT* Value
   , OPTIONAL BYREF Type AS VARIANT _                   ' __in_opt VARIANT* Type
   )                                                    ' void
   ' =====================================================================================
   METHOD RegDelete <2002> ( _                          ' VTable offset = 60
     BYVAL Name AS STRING _                             ' __in BSTR Name
   )                                                    ' void
   ' =====================================================================================

   ' =====================================================================================
   ' IWshShell2 Methods
   ' =====================================================================================
   METHOD LogEvent <3000> ( _                           ' VTable offset = 64
     BYREF Type AS VARIANT _                            ' __in VARIANT* Type
   , BYVAL Message AS STRING _                          ' __in BSTR Message
   , OPTIONAL BYVAL Target AS STRING _                  ' __in_opt BSTR Target = L""
   ) AS INTEGER                                         ' __out_retval VARIANT_BOOL* out_Success
   ' =====================================================================================
   METHOD AppActivate <3010> ( _                        ' VTable offset = 68
     BYREF App AS VARIANT _                             ' __in VARIANT* App
   , OPTIONAL BYREF Wait AS VARIANT _                   ' __in_opt VARIANT* Wait
   ) AS INTEGER                                         ' __out_retval VARIANT_BOOL* out_Success
   ' =====================================================================================
   METHOD SendKeys <3011> ( _                           ' VTable offset = 72
     BYVAL Keys AS STRING _                             ' __in BSTR Keys
   , OPTIONAL BYREF Wait AS VARIANT _                   ' __in_opt VARIANT* Wait
   )                                                    ' void
   ' =====================================================================================

   ' =====================================================================================
   ' IWshShell3 Methods
   ' =====================================================================================
   METHOD Exec <3012> ( _                               ' VTable offset = 76
     BYVAL Command AS STRING _                          ' __in BSTR Command
   ) AS IWshExec                                        ' __out_retval IWshExec** ppExec
   ' =====================================================================================
   PROPERTY GET CurrentDirectory <3013> ( _             ' VTable offset = 80
   ) AS STRING                                          ' __out_retval BSTR* out_Directory
   ' =====================================================================================
   PROPERTY SET CurrentDirectory <3013> ( _             ' VTable offset = 84
     BYVAL out_Directory AS STRING _                    ' __in BSTR out_Directory
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshShell3_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshExec
' IID = {08FED190-BE19-11D3-A28B-00104BD35090}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IWshExec_INTERFACE_DEFINED)
    %IWshExec_INTERFACE_DEFINED = 1

INTERFACE IWshExec $IID_IWshExec

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET Status <1> ( _                          ' VTable offset = 28
   ) AS LONG                                            ' __out_retval WshExecStatus* Status
   ' =====================================================================================
   PROPERTY GET StdIn <3> ( _                           ' VTable offset = 32
   ) AS ITextStream                                     ' __out_retval ITextStream** ppts
   ' =====================================================================================
   PROPERTY GET StdOut <4> ( _                          ' VTable offset = 36
   ) AS ITextStream                                     ' __out_retval ITextStream** ppts
   ' =====================================================================================
   PROPERTY GET StdErr <5> ( _                          ' VTable offset = 40
   ) AS ITextStream                                     ' __out_retval ITextStream** ppts
   ' =====================================================================================
   PROPERTY GET ProcessID <6> ( _                       ' VTable offset = 44
   ) AS LONG                                            ' __out_retval long* PID
   ' =====================================================================================
   PROPERTY GET ExitCode <7> ( _                        ' VTable offset = 48
   ) AS LONG                                            ' __out_retval long* ExitCode
   ' =====================================================================================
   METHOD Terminate <8> ( _                             ' VTable offset = 52
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshExec_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshShortcut
' IID = {F935DC23-1CF0-11D0-ADB9-00C04FD58A0B}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IWshShortcut_INTERFACE_DEFINED)
    %IWshShortcut_INTERFACE_DEFINED = 1

INTERFACE IWshShortcut $IID_IWshShortcut

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET FullName <0> ( _                        ' VTable offset = 28
   ) AS STRING                                          ' __out_retval BSTR* out_FullName
   ' =====================================================================================
   PROPERTY GET Arguments <1000> ( _                    ' VTable offset = 32
   ) AS STRING                                          ' __out_retval BSTR* out_Arguments
   ' =====================================================================================
   PROPERTY SET Arguments <1000> ( _                    ' VTable offset = 36
     BYVAL out_Arguments AS STRING _                    ' __in BSTR out_Arguments
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET Description <1001> ( _                  ' VTable offset = 40
   ) AS STRING                                          ' __out_retval BSTR* out_Description
   ' =====================================================================================
   PROPERTY SET Description <1001> ( _                  ' VTable offset = 44
     BYVAL out_Description AS STRING _                  ' __in BSTR out_Description
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET Hotkey <1002> ( _                       ' VTable offset = 48
   ) AS STRING                                          ' __out_retval BSTR* out_HotKey
   ' =====================================================================================
   PROPERTY SET Hotkey <1002> ( _                       ' VTable offset = 52
     BYVAL out_HotKey AS STRING _                       ' __in BSTR out_HotKey
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET IconLocation <1003> ( _                 ' VTable offset = 56
   ) AS STRING                                          ' VT_BSTR out_IconPath
   ' =====================================================================================
   PROPERTY SET IconLocation <1003> ( _                 ' VTable offset = 60
     BYVAL out_IconPath AS STRING _                     ' __out_retval BSTR* out_IconPath
   )                                                    ' void
   ' =====================================================================================
   PROPERTY SET RelativePath <1004> ( _                 ' VTable offset = 64
     BYVAL out_IconPath AS STRING _                     ' __in BSTR out_IconPath
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET TargetPath <1005> ( _                   ' VTable offset = 68
   ) AS STRING                                          ' __out_retval BSTR* out_Path
   ' =====================================================================================
   PROPERTY SET TargetPath <1005> ( _                   ' VTable offset = 72
     BYVAL out_Path AS STRING _                         ' __in BSTR out_Path
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET WindowStyle <1006> ( _                  ' VTable offset = 76
   ) AS LONG                                            ' __out_retval int* out_ShowCmd
   ' =====================================================================================
   PROPERTY SET WindowStyle <1006> ( _                  ' VTable offset = 80
     BYVAL out_ShowCmd AS LONG _                        ' __in int out_ShowCmd
   )                                                    ' void
   ' =====================================================================================
   PROPERTY GET WorkingDirectory <1007> ( _             ' VTable offset = 84
   ) AS STRING                                          ' __out_retval BSTR* out_WorkingDirectory
   ' =====================================================================================
   PROPERTY SET WorkingDirectory <1007> ( _             ' VTable offset = 88
     BYVAL out_WorkingDirectory AS STRING _             ' __in BSTR out_WorkingDirectory
   )                                                    ' void
   ' =====================================================================================
   METHOD Load <2000> ( _                               ' VTable offset = 92
     BYVAL PathLink AS STRING _                         ' __in BSTR PathLink
   )                                                    ' void
   ' =====================================================================================
   METHOD Save <2001> ( _                               ' VTable offset = 96
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshShortcut_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshNetwork
' IID = {F935DC25-1CF0-11D0-ADB9-00C04FD58A0B}
' Attributes = 4176 [&H1050] [Hidden] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IWshNetwork_INTERFACE_DEFINED)
    %IWshNetwork_INTERFACE_DEFINED = 1

INTERFACE IWshNetwork $IID_IWshNetwork

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET UserDomain <1610743808> ( _             ' VTable offset = 28
   ) AS STRING                                          ' __out_retval BSTR* out_UserDomain
   ' =====================================================================================
   PROPERTY GET UserName <1610743809> ( _               ' VTable offset = 32
   ) AS STRING                                          ' __out_retval BSTR* out_UserName
   ' =====================================================================================
   PROPERTY GET UserProfile <1610743810> ( _            ' VTable offset = 36
   ) AS STRING                                          ' __out_retval BSTR* out_UserProfile
   ' =====================================================================================
   PROPERTY GET ComputerName <1610743811> ( _           ' VTable offset = 40
   ) AS STRING                                          ' __out_retval BSTR* out_ComputerName
   ' =====================================================================================
   PROPERTY GET Organization <1610743812> ( _           ' VTable offset = 44
   ) AS STRING                                          ' __out_retval BSTR* out_Organization
   ' =====================================================================================
   PROPERTY GET Site <1610743813> ( _                   ' VTable offset = 48
   ) AS STRING                                          ' __out_retval BSTR* out_Site
   ' =====================================================================================
   METHOD MapNetworkDrive <1000> ( _                    ' VTable offset = 52
     BYVAL LocalName AS STRING _                        ' __in BSTR LocalName
   , BYVAL RemoteName AS STRING _                       ' __in BSTR RemoteName
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   , OPTIONAL BYREF UserName AS VARIANT _               ' __in_opt VARIANT* UserName
   , OPTIONAL BYREF Password AS VARIANT _               ' __in_opt VARIANT* Password
   )                                                    ' void
   ' =====================================================================================
   METHOD RemoveNetworkDrive <1001> ( _                 ' VTable offset = 56
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , OPTIONAL BYREF Force AS VARIANT _                  ' __in_opt VARIANT* Force
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   )                                                    ' void
   ' =====================================================================================
   METHOD EnumNetworkDrives <1002> ( _                  ' VTable offset = 60
   ) AS IWshCollection                                  ' __out_retval IWshCollection** out_Enum
   ' =====================================================================================
   METHOD AddPrinterConnection <2000> ( _               ' VTable offset = 64
     BYVAL LocalName AS STRING _                        ' __in BSTR LocalName
   , BYVAL RemoteName AS STRING _                       ' __in BSTR RemoteName
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   , OPTIONAL BYREF UserName AS VARIANT _               ' __in_opt VARIANT* UserName
   , OPTIONAL BYREF Password AS VARIANT _               ' __in_opt VARIANT* Password
   )                                                    ' void
   ' =====================================================================================
   METHOD RemovePrinterConnection <2001> ( _            ' VTable offset = 68
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , OPTIONAL BYREF Force AS VARIANT _                  ' __in_opt VARIANT* Force
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   )                                                    ' void
   ' =====================================================================================
   METHOD EnumPrinterConnections <2002> ( _             ' VTable offset = 72
   ) AS IWshCollection                                  ' __out_retval IWshCollection** out_Enum
   ' =====================================================================================
   METHOD SetDefaultPrinter <2003> ( _                  ' VTable offset = 76
     BYVAL Name AS STRING _                             ' __in BSTR Name
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshNetwork_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshNetwork2
' IID = {24BE5A31-EDFE-11D2-B933-00104B365C9F}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IWshNetwork
' ########################################################################################

#IF NOT %DEF(%IWshNetwork2_INTERFACE_DEFINED)
    %IWshNetwork2_INTERFACE_DEFINED = 1

INTERFACE IWshNetwork2 $IID_IWshNetwork2

   INHERIT IDispatch

   ' =====================================================================================
   ' IWshNetwork Methods
   ' =====================================================================================
   PROPERTY GET UserDomain <1610743808> ( _             ' VTable offset = 28
   ) AS STRING                                          ' __out_retval BSTR* out_UserDomain
   ' =====================================================================================
   PROPERTY GET UserName <1610743809> ( _               ' VTable offset = 32
   ) AS STRING                                          ' __out_retval BSTR* out_UserName
   ' =====================================================================================
   PROPERTY GET UserProfile <1610743810> ( _            ' VTable offset = 36
   ) AS STRING                                          ' __out_retval BSTR* out_UserProfile
   ' =====================================================================================
   PROPERTY GET ComputerName <1610743811> ( _           ' VTable offset = 40
   ) AS STRING                                          ' __out_retval BSTR* out_ComputerName
   ' =====================================================================================
   PROPERTY GET Organization <1610743812> ( _           ' VTable offset = 44
   ) AS STRING                                          ' __out_retval BSTR* out_Organization
   ' =====================================================================================
   PROPERTY GET Site <1610743813> ( _                   ' VTable offset = 48
   ) AS STRING                                          ' __out_retval BSTR* out_Site
   ' =====================================================================================
   METHOD MapNetworkDrive <1000> ( _                    ' VTable offset = 52
     BYVAL LocalName AS STRING _                        ' __in BSTR LocalName
   , BYVAL RemoteName AS STRING _                       ' __in BSTR RemoteName
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   , OPTIONAL BYREF UserName AS VARIANT _               ' __in_opt VARIANT* UserName
   , OPTIONAL BYREF Password AS VARIANT _               ' __in_opt VARIANT* Password
   )                                                    ' void
   ' =====================================================================================
   METHOD RemoveNetworkDrive <1001> ( _                 ' VTable offset = 56
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , OPTIONAL BYREF Force AS VARIANT _                  ' __in_opt VARIANT* Force
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   )                                                    ' void
   ' =====================================================================================
   METHOD EnumNetworkDrives <1002> ( _                  ' VTable offset = 60
   ) AS IWshCollection                                  ' __out_retval IWshCollection** out_Enum
   ' =====================================================================================
   METHOD AddPrinterConnection <2000> ( _               ' VTable offset = 64
     BYVAL LocalName AS STRING _                        ' __in BSTR LocalName
   , BYVAL RemoteName AS STRING _                       ' __in BSTR RemoteName
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   , OPTIONAL BYREF UserName AS VARIANT _               ' __in_opt VARIANT* UserName
   , OPTIONAL BYREF Password AS VARIANT _               ' __in_opt VARIANT* Password
   )                                                    ' void
   ' =====================================================================================
   METHOD RemovePrinterConnection <2001> ( _            ' VTable offset = 68
     BYVAL Name AS STRING _                             ' __in BSTR Name
   , OPTIONAL BYREF Force AS VARIANT _                  ' __in_opt VARIANT* Force
   , OPTIONAL BYREF UpdateProfile AS VARIANT _          ' __in_opt VARIANT* UpdateProfile
   )                                                    ' void
   ' =====================================================================================
   METHOD EnumPrinterConnections <2002> ( _             ' VTable offset = 72
   ) AS IWshCollection                                  ' __out_retval IWshCollection** out_Enum
   ' =====================================================================================
   METHOD SetDefaultPrinter <2003> ( _                  ' VTable offset = 76
     BYVAL Name AS STRING _                             ' __in BSTR Name
   )                                                    ' void
   ' =====================================================================================

   ' =====================================================================================
   ' IWshNetwork2 Methods
   ' =====================================================================================
   METHOD AddWindowsPrinterConnection <2004> ( _        ' VTable offset = 80
     BYVAL PrinterName AS STRING _                      ' __in BSTR PrinterName
   , OPTIONAL BYVAL DriverName AS STRING _              ' __in_opt BSTR DriverName = L""
   , OPTIONAL BYVAL Port AS STRING _                    ' __in_opt BSTR Port = L"LPT1"
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshNetwork2_INTERFACE_DEFINED__ */

' ########################################################################################
' Interface name = IWshURLShortcut
' IID = {F935DC2B-1CF0-11D0-ADB9-00C04FD58A0B}
' Attributes = 4160 [&H1040] [Dual] [Dispatchable]
' Inherited interface = IDispatch
' ########################################################################################

#IF NOT %DEF(%IWshURLShortcut_INTERFACE_DEFINED)
    %IWshURLShortcut_INTERFACE_DEFINED = 1

INTERFACE IWshURLShortcut $IID_IWshURLShortcut

   INHERIT IDispatch

   ' =====================================================================================
   PROPERTY GET FullName <0> ( _                        ' VTable offset = 28
   ) AS STRING                                          ' __out_retval BSTR* out_FullName
   ' =====================================================================================
   PROPERTY GET TargetPath <1005> ( _                   ' VTable offset = 32
   ) AS STRING                                          ' __out_retval BSTR* out_Path
   ' =====================================================================================
   PROPERTY SET TargetPath <1005> ( _                   ' VTable offset = 36
     BYVAL out_Path AS STRING _                         ' __in BSTR out_Path
   )                                                    ' void
   ' =====================================================================================
   METHOD Load <2000> ( _                               ' VTable offset = 40
     BYVAL PathLink AS STRING _                         ' __in BSTR PathLink
   )                                                    ' void
   ' =====================================================================================
   METHOD Save <2001> ( _                               ' VTable offset = 44
   )                                                    ' void
   ' =====================================================================================

END INTERFACE

#ENDIF   ' /* __IWshURLShortcut_INTERFACE_DEFINED__ */

#ENDIF   ' #IF NOT %DEF(%WSHOM_INC)

'////////////////////////////////////////////////////////////////////////////////////////////////////////
'#INCLUDE ONCE "WSHOM.INC"

'-----------------------------------------------------------------
' Equates
'-----------------------------------------------------------------
%ID_CLOSE           = -32768
%ID_RESTORE         = -32767
%ID_MAXIMIZE        = -32766
%ID_MINIMIZE        = -32765
%ID_LED             = -32764
%ID_DOCKIN          = -32763
%ID_DOCKOUT         = -32762
%ID_LISTFNAME       = -32761
%ID_LISTIMAGE       = -32760
%ID_COLORPICKBUTTON = -32759

$Anti       = "\"
$Dot        = "."
$zLim       = "|"

'-----------------------------------------------------------------
' TYPE and UNION structures:  15
'-----------------------------------------------------------------
TYPE SHITEMID
    cb AS LONG
    abID AS BYTE
END TYPE

TYPE ITEMIDLIST
    mkid AS SHITEMID
END TYPE

' Custom types
TYPE COLORBYTES
    B AS BYTE
    G AS BYTE
    R AS BYTE
    A AS BYTE
END TYPE

TYPE COLORLONG
   longval AS LONG
END TYPE

TYPE MYRECTF
    nLEFT   AS SINGLE
    nTop    AS SINGLE
    nRIGHT  AS SINGLE
    nBottom AS SINGLE
END TYPE

TYPE MYBITMAPINFO
    bmiHeader AS BITMAPINFOHEADER
    bmiColors(256) AS RGBQUAD ' Patrice
END TYPE

DECLARE FUNCTION MyCreateDIBSection LIB "GDI32.DLL" ALIAS "CreateDIBSection" (BYVAL hdc AS DWORD, pbmi AS MYBITMAPINFO, BYVAL dwUsage AS DWORD, BYVAL ppvBits AS DWORD, BYVAL hSection AS DWORD, BYVAL dwOffset AS DWORD) AS DWORD
DECLARE FUNCTION SHGetSpecialFolderLocation LIB "SHELL32.DLL" ALIAS "SHGetSpecialFolderLocation" (BYVAL hwndOwner AS DWORD, BYVAL nFolder AS LONG, pidl AS ANY) AS LONG
DECLARE FUNCTION SHGetPathFromIDList LIB "SHELL32.DLL" ALIAS "SHGetPathFromIDListA" (BYVAL pidList AS DWORD, lpBuffer AS ASCIIZ) AS LONG
DECLARE SUB      CoTaskMemFree LIB "ole32.dll" ALIAS "CoTaskMemFree" (BYVAL pMem AS DWORD)

'------------------------------------------------------------------------------------------
' GDIPLUS section
'------------------------------------------------------------------------------------------
$GDIPLUSIMG = ".DIB.EMF.GIF.JPG.JPEG.PNG.TIF.TIFF.WMF."
$GDIPLUSEXT = $GDIPLUSIMG + "BMP.ICO."
%UnitPixel  = 2 ' Each unit is one device pixel.

%MatrixOrderPrepend = 0
%MatrixOrderAppend = 1
%CombineModeIntersect = 1

%FontStyleRegular = 0
%TextRenderingHintSystemDefault            = 0 ' Glyph with system default rendering hint
%TextRenderingHintSingleBitPerPixelGridFit = 1 ' Glyph bitmap with hinting
%TextRenderingHintSingleBitPerPixel        = 2 ' Glyph bitmap without hinting
%TextRenderingHintAntiAliasGridFit         = 3 ' Glyph anti-alias bitmap with hinting
%TextRenderingHintAntiAlias                = 4 ' Glyph anti-alias bitmap without hinting
%TextRenderingHintClearTypeGridFit         = 5 ' Glyph CT bitmap with hinting
%TextRenderingDefault                      = %TextRenderingHintClearTypeGridFit

'%ZD_TextHorzUp = &H0                  ' Horizontal text orientation
'%ZD_TextVertUp = &H1                  ' Vertical text orientation from bottom to top
'%ZD_TextVertDn = &H2                  ' Vertical text orientation from top to bottom

%WrapModeTile        = 0
%WrapModeTileFlipX   = 1
%WrapModeTileFlipY   = 2
%WrapModeTileFlipXY  = 3
%WrapModeClamp       = 4

%SmoothingModeAntiAlias = 4

TYPE GdiplusStartupInput
   GdiplusVersion AS LONG             ' Must be 1
   DebugEventCallback AS LONG         ' Ignored on free builds
   SuppressBackgroundThread AS LONG   ' FALSE unless you're prepared to call
                                      ' the hook/unhook functions properly
   SuppressExternalCodecs AS LONG     ' FALSE unless you want GDI+ only to use
                                      ' its internal image codecs.
END TYPE

DECLARE FUNCTION GdiplusStartup LIB "gdiplus.dll" ALIAS "GdiplusStartup" (token&, inputbuf AS GdiplusStartupInput, OPTIONAL BYVAL outputbuf&) AS LONG
DECLARE FUNCTION GdiplusShutdown LIB "gdiplus.dll" ALIAS "GdiplusShutdown" (BYVAL token&) AS LONG
DECLARE FUNCTION GdipLoadImageFromFile LIB "gdiplus.dll" ALIAS "GdipLoadImageFromFile" (zFilName AS ASCIIZ, nImage&) AS LONG
DECLARE FUNCTION GdipGetImageWidth LIB "gdiplus.dll" ALIAS "GdipGetImageWidth" (BYVAL nImage&, nWidth&) AS LONG
DECLARE FUNCTION GdipGetImageHeight LIB "gdiplus.dll" ALIAS "GdipGetImageHeight" (BYVAL nImage&, Height&) AS LONG
DECLARE FUNCTION GdipDisposeImage LIB "gdiplus.dll" ALIAS "GdipDisposeImage" (BYVAL nImage&) AS LONG
DECLARE FUNCTION GdipCreateFromHDC LIB "gdiplus.dll" ALIAS "GdipCreateFromHDC" (BYVAL hdc&, graphics&) AS LONG
DECLARE FUNCTION GdipDrawImageRectRectI LIB "gdiplus.dll" ALIAS "GdipDrawImageRectRectI" (BYVAL graphics&, BYVAL nImage&, BYVAL dstx&, BYVAL dsty&, BYVAL dstwidth&, BYVAL dstheight&, BYVAL srcx&, BYVAL srcy&, BYVAL srcwidth&, BYVAL srcheight&, _
                                                                                          BYVAL srcUnit&, OPTIONAL BYVAL imageAttributes&, OPTIONAL BYVAL pCALLBACK&, OPTIONAL BYVAL callbackData&) AS LONG
DECLARE FUNCTION GdipCreateStringFormat LIB "gdiplus.dll" ALIAS "GdipCreateStringFormat" (BYVAL formatAttributes&, BYVAL language AS INTEGER, StringFormat&) AS LONG
DECLARE FUNCTION GdipDeleteGraphics LIB "gdiplus.dll" ALIAS "GdipDeleteGraphics" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipCreateFont LIB "gdiplus.dll" ALIAS "GdipCreateFont" (BYVAL fontFamily&, BYVAL emSize!, BYVAL style&, BYVAL unit&, createdfont&) AS LONG
DECLARE FUNCTION GdipCreateFontFromDC LIB "gdiplus.dll" ALIAS "GdipCreateFontFromDC" (BYVAL hDC&, createdfont&) AS LONG
DECLARE FUNCTION GdipCreateFontFamilyFromName LIB "gdiplus.dll" ALIAS "GdipCreateFontFamilyFromName" (zFontName AS ASCIIZ, BYVAL fontCollection&, fontFamily&) AS LONG
DECLARE FUNCTION GdipDeleteFont LIB "gdiplus.dll" ALIAS "GdipDeleteFont" (BYVAL curFont&) AS LONG
DECLARE FUNCTION GdipMeasureString LIB "gdiplus.dll" ALIAS "GdipMeasureString" (BYVAL graphics&, zString AS ASCIIZ, BYVAL length&, BYVAL thefont&, layoutRect AS MYRECTF, BYVAL StringFormat&, boundingBox AS MYRECTF, _
                                                                                codepointsFitted&, linesFilled&) AS LONG
DECLARE FUNCTION GdipDeleteFontFamily LIB "gdiplus.dll" ALIAS "GdipDeleteFontFamily" (BYVAL fontFamily&) AS LONG
DECLARE FUNCTION GdipDeleteBrush LIB "gdiplus.dll" ALIAS "GdipDeleteBrush" (BYVAL brush&) AS LONG
DECLARE FUNCTION GdipResetWorldTransform LIB "gdiplus.dll" ALIAS "GdipResetWorldTransform" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipDeleteStringFormat LIB "gdiplus.dll" ALIAS "GdipDeleteStringFormat" (BYVAL StringFormat&) AS LONG
DECLARE FUNCTION GdipDrawString LIB "gdiplus.dll" ALIAS "GdipDrawString" (BYVAL graphics&, zStr AS ASCIIZ, BYVAL length&, BYVAL thefont&, layoutRect AS MYRECTF, BYVAL StringFormat&, BYVAL brush&) AS LONG
DECLARE FUNCTION GdipCreateSolidFill LIB "gdiplus.dll" ALIAS "GdipCreateSolidFill" (BYVAL argb&, brush&) AS LONG
DECLARE FUNCTION GdipSetTextRenderingHint LIB "gdiplus.dll" ALIAS "GdipSetTextRenderingHint" (BYVAL graphics&, BYVAL mode&) AS LONG
DECLARE FUNCTION GdipRotateWorldTransform LIB "gdiplus.dll" ALIAS "GdipRotateWorldTransform" (BYVAL graphics&, BYVAL angle!, BYVAL order&) AS LONG
DECLARE FUNCTION GdipSetStringFormatFlags LIB "gdiplus.dll" ALIAS "GdipSetStringFormatFlags" (BYVAL StringFormat&, BYVAL flags&) AS LONG

DECLARE FUNCTION GdipSetStringFormatAlign LIB "gdiplus.dll" ALIAS "GdipSetStringFormatAlign" (BYVAL StringFormat&, BYVAL align&) AS LONG
DECLARE FUNCTION GdipSetStringFormatLineAlign LIB "gdiplus.dll" ALIAS "GdipSetStringFormatLineAlign" (BYVAL StringFormat&, BYVAL align&) AS LONG

DECLARE FUNCTION GdipTranslateWorldTransform LIB "gdiplus.dll" ALIAS "GdipTranslateWorldTransform" (BYVAL graphics&, BYVAL dx!, BYVAL dy!, BYVAL order&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromHICON LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromHICON" (BYVAL hicon&, nBitmap&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromHBITMAP LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromHBITMAP" (BYVAL hbm&, BYVAL hpal&, nBitmap&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromGraphics LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromGraphics" (BYVAL nWidth&, BYVAL Height&, BYVAL graphics&, nBitmap&) AS LONG
DECLARE FUNCTION GdipSetInterpolationMode LIB "gdiplus.dll" ALIAS "GdipSetInterpolationMode" (BYVAL graphics&, BYVAL interpolation&) AS LONG
DECLARE FUNCTION GdipDrawLineI LIB "gdiplus.dll" ALIAS "GdipDrawLineI" (BYVAL graphics&, BYVAL pen&, BYVAL x1&, BYVAL y1&, BYVAL x2&, BYVAL y2&) AS LONG
DECLARE FUNCTION GdipDeletePen LIB "gdiplus.dll" ALIAS "GdipDeletePen" (BYVAL pen&) AS LONG
DECLARE FUNCTION GdipCreatePen1 LIB "gdiplus.dll" ALIAS "GdipCreatePen1" (BYVAL Colr&, BYVAL nWidth!, BYVAL unit&, pen&) AS LONG
DECLARE FUNCTION GdipSetClipRectI LIB "gdiplus.dll" ALIAS "GdipSetClipRectI" (BYVAL graphics&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&, BYVAL CombineMd&) AS LONG
DECLARE FUNCTION GdipResetClip LIB "gdiplus.dll" ALIAS "GdipResetClip" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipFillRectangleI LIB "gdiplus.dll" ALIAS "GdipFillRectangleI" (BYVAL graphics&, BYVAL brush&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&) AS LONG
DECLARE FUNCTION GdipCreateLineBrushI LIB "gdiplus.dll" ALIAS "GdipCreateLineBrushI" (point1 AS POINTAPI, point2 AS POINTAPI, BYVAL color1&, BYVAL color2&, BYVAL WrapMd&, lineGradient&) AS LONG
DECLARE FUNCTION GdipCreatePen2 LIB "gdiplus.dll" ALIAS "GdipCreatePen2" (BYVAL brush&, BYVAL nWidth!, BYVAL unit&, pen&) AS LONG
DECLARE FUNCTION GdipFillEllipseI LIB "gdiplus.dll" ALIAS "GdipFillEllipseI" (BYVAL graphics&, BYVAL brush&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&) AS LONG
DECLARE FUNCTION GdipSetSmoothingMode LIB "gdiplus.dll" ALIAS "GdipSetSmoothingMode" (BYVAL graphics&, BYVAL SmoothingMd&) AS LONG
DECLARE FUNCTION GdipCloneBitmapAreaI LIB "gdiplus.dll" ALIAS "GdipCloneBitmapAreaI" (BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&, BYVAL PixelFormat&, BYVAL srcBitmap&, dstBitmap&) AS LONG
DECLARE FUNCTION GdipDrawImageRectI LIB "gdiplus.dll" ALIAS "GdipDrawImageRectI" (BYVAL graphics&, BYVAL nImage&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&) AS LONG
DECLARE FUNCTION GdipImageRotateFlip LIB "gdiplus.dll" ALIAS "GdipImageRotateFlip" (BYVAL nImage&, BYVAL rfType&) AS LONG

%WM_DROPFILES = &H233
DECLARE SUB DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS DWORD, BYVAL fAccept AS LONG)
DECLARE SUB DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS DWORD)
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL hDrop AS DWORD, BYVAL uiFile AS DWORD, lpStr AS ASCIIZ, BYVAL cch AS DWORD) AS DWORD

'// Static function to save the main window handle.
FUNCTION zsMainWindow(BYVAL hMain AS LONG) AS LONG
    STATIC WasMain AS LONG
    IF hMain THEN
       WasMain = hMain
    END IF
    FUNCTION = WasMain
END FUNCTION

'// Retrieve the current module instance.
FUNCTION zsInstance () AS LONG
    FUNCTION = GetModuleHandle("")
END FUNCTION

'// To detect the language being used on the host computer.
FUNCTION IsFrench() AS LONG
    L$ = SPACE$(6)
    CALL GetLocaleInfo(%LOCALE_USER_DEFAULT, %LOCALE_SENGLANGUAGE, BYVAL STRPTR(L$), LEN(L$))
    IF UCASE$(L$) = "FRENCH" THEN FUNCTION = -1
END FUNCTION

'// Safe delete for GDI objects.
SUB zsDeleteObject (hObject AS LONG)
    IF hObject THEN CALL DeleteObject(hObject): hObject = 0
END SUB

FUNCTION zsGetMainItem(BYVAL UseID AS LONG) AS LONG
    FUNCTION = GetDlgItem(zsMainWindow(0), UseID)
END FUNCTION

'// Create GDIPLUS image from any of the supported graphic format.
'// I mainly use full 32-bit PNG with transparent section and/or variable opacity
FUNCTION zsCreateImageFromFile (zFullName AS ASCIIZ) AS LONG
    LOCAL So, ImageType, Img AS LONG
    So = INSTR(-1, zFullName, $Dot)
    IF NOT ISFILE(zFullName) THEN So = 0
    IF So THEN
       ImageType = INSTR($GDIPLUSEXT, UCASE$(MID$(zFullName, So)) + $Dot)
       IF ImageType THEN
        ' Load the image
          IF GdipLoadImageFromFile((UCODE$(zFullName)), Img) = 0 THEN
             FUNCTION = Img
          END IF
       END IF
    END IF
END FUNCTION

SUB zsDisposeImage (BYREF Img AS LONG)
    IF Img THEN CALL GdipDisposeImage(Img): Img = 0
END SUB

'// Add image resource to LISTFNAME and LISTIMAGE
FUNCTION zsAddResource(BYVAL sResource AS STRING) AS LONG

    LOCAL UseStyle, hMain, hLISTFNAME, hLISTIMAGE, nIndex, hImage, nCount AS LONG
    LOCAL zTmp AS ASCIIZ * 265 ' %MAX_PATH + 5
    LOCAL zData AS ASCIIZ * 16
    CALL GetShortPathName((sResource), zTmp, SIZEOF(zTmp))
    zTmp = UCASE$(zTmp)
    hMain = zsMainWindow(0)

    UseStyle = %WS_CHILD OR %LBS_HASSTRINGS
    hLISTFNAME = zsGetMainItem(%ID_LISTFNAME)
    IF hLISTFNAME = 0 THEN
       hLISTFNAME = CreateWindowEx(0, "LISTBOX", "", UseStyle, 0, 0, 0, 0, hMain, %ID_LISTFNAME, zsInstance(), BYVAL 0)
    END IF
    hLISTIMAGE = zsGetMainItem(%ID_LISTIMAGE)
    IF hLISTIMAGE = 0 THEN
       hLISTIMAGE = CreateWindowEx(0, "LISTBOX", "", UseStyle, 0, 0, 0, 0, hMain, %ID_LISTIMAGE, zsInstance(), BYVAL 0)
    END IF

    IF hLISTFNAME THEN
       nIndex = SendMessage(hLISTFNAME, %LB_FINDSTRING, -1, VARPTR(zTmp))
       IF nIndex > -1 THEN '// We found same resource
          CALL SendMessage(hLISTIMAGE, %LB_GETTEXT, nIndex, VARPTR(zData))
          hImage = VAL(zData)
'         // Get full string item
          CALL SendMessage(hLISTFNAME, %LB_GETTEXT, nIndex, VARPTR(zTmp))
'         // Delete item before update
          CALL SendMessage(hLISTFNAME, %LB_DELETESTRING, nIndex, 0)
          CALL SendMessage(hLISTIMAGE, %LB_DELETESTRING, nIndex, 0)
          sResource = LEFT$(zTmp, LEN(zTmp) - 4)
          nCount = VAL(RIGHT$(zTmp, 4)) + 1
          zTmp = sResource + RIGHT$("0000" + LTRIM$(STR$(nCount)), 4)
          IF SendMessage(hLISTFNAME, %LB_ADDSTRING, 0, VARPTR(zTmp)) < 0 THEN hImage = 0
          IF SendMessage(hLISTIMAGE, %LB_ADDSTRING, 0, VARPTR(zData)) < 0 THEN hImage = 0
       ELSE                     '// Resource doesn't exist, add it
          hImage = zsCreateImageFromFile((sResource))
          IF hImage THEN
             zTmp = zTmp + "0001"
             IF SendMessage(hLISTFNAME, %LB_ADDSTRING, 0, VARPTR(zTmp)) < 0 THEN CALL zsDisposeImage(hImage)
             IF hImage THEN
                zData = STR$(hImage)
                IF SendMessage(hLISTIMAGE, %LB_ADDSTRING, 0, VARPTR(zData)) < 0 THEN hImage = 0
             END IF
          END IF
       END IF
    END IF
    FUNCTION = hImage
END FUNCTION

'// Remove all image resource from memory
'// Must be done just before to exit the main program in case zsAddResource
'// has been used to store image handles that are not tied to a specific control.
'// For example: Image used in an ownerdrawn menu.
SUB zsRemoveAllImageResource()
    LOCAL hImage, nIndex, nCount, hLISTIMAGE AS LONG
    LOCAL zData AS ASCIIZ * 16
    hLISTIMAGE = zsGetMainItem(%ID_LISTIMAGE)
    IF hLISTIMAGE THEN
       nCount = SendMessage(hLISTIMAGE, %LB_GETCOUNT, 0, 0)
       IF nCount > 0 THEN
          FOR nIndex = 0 TO nCount -1
              CALL SendMessage(hLISTIMAGE, %LB_GETTEXT, nIndex, VARPTR(zData))
              hImage = VAL(zData): CALL zsDisposeImage(hImage)
          NEXT
       END IF
'      // Destroy LISTIMAGE
       CALL DestroyWindow(hLISTIMAGE)
    END IF
END SUB

'// Return width and height size of a GDIPLUS image.
SUB zsGetImageSize (BYVAL Img AS LONG, imgW AS LONG, imgH AS LONG)
    CALL GdipGetImageWidth(Img, imgW)
    CALL GdipGetImageHeight(Img, imgH)
END SUB

FUNCTION zsDisplayDC() AS LONG
    FUNCTION = CreateIC("DISPLAY", BYVAL 0, BYVAL 0, BYVAL 0)
END FUNCTION

FUNCTION zsFileOperation(BYVAL hDlg AS LONG, zSrce AS ASCIIZ, zTarget AS ASCIIZ, zTitle AS ASCIIZ, BYVAL FlagDialog AS LONG, BYVAL wFunc AS LONG) AS LONG
    LOCAL ErrCode AS LONG
    DIM Sh AS SHFILEOPSTRUCT
    IF ISFILE(zSrce) THEN
       Sh.hWnd = hDlg
       Sh.wFunc = wFunc
       Sh.pFrom = VARPTR(zSrce)
       Sh.pTo = VARPTR(zTarget)
       Sh.fFlags = %FOF_SILENT OR %FOF_NOCONFIRMATION OR %FOF_NOCONFIRMMKDIR
       IF FlagDialog THEN
          Sh.lpszProgressTitle = VARPTR(zTitle)
          Sh.fFlags = %FOF_NOCONFIRMATION OR %FOF_NOCONFIRMMKDIR OR %FOF_SIMPLEPROGRESS
       END IF
       ErrCode = SHFileOperation(Sh)
    ELSE
       ErrCode = 2 ' The system cannot find the file specified
    END IF
    FUNCTION = ErrCode
END FUNCTION

FUNCTION zsFileCopy(BYVAL hDlg AS LONG, zSrce AS ASCIIZ, zTarget AS ASCIIZ, zTitle AS ASCIIZ, BYVAL FlagDialog AS LONG) AS LONG
    FUNCTION = zsFileOperation (hDlg, zSrce, zTarget, zTitle, FlagDialog, %FO_COPY)
END FUNCTION

' Generic open file function
FUNCTION zsFOpen (zFilName AS ASCIIZ, BYVAL AccessMode AS LONG, BYVAL ShareMode AS LONG, hFile AS LONG) AS LONG

    LOCAl AccessIs, ShareIs, FlagAndAttribute AS LONG

    AccessMode = MIN(MAX(AccessMode, 0), 2)  ' Coherce between 0-2
    IF AccessMode = 0 THEN                   ' 0 Open for read only.
       AccessIs = %GENERIC_READ
    ELSEIF AccessMode = 1 THEN               ' 1 Open for write only.
       AccessIs = %GENERIC_WRITE
    ELSE                                     ' 2 Open for read and write.
       AccessIs = %GENERIC_READ OR %GENERIC_WRITE
    END IF

    ShareMode = MIN(MAX(ShareMode, 1), 4)    ' Coherce between 1-4
    IF ShareMode = 1 THEN                    ' 1 Deny read/write access.
       ShareIs = 0
    ELSEIF ShareMode = 2 THEN                ' 2 Deny write access.
       ShareIs =  %FILE_SHARE_READ
    ELSEIF ShareMode = 3 THEN                ' 3 Deny read access.
       ShareIs =  %FILE_SHARE_WRITE
    ELSE                                     ' 4 Deny none (full share mode).
       ShareIs =  %FILE_SHARE_READ OR %FILE_SHARE_WRITE
    END IF

    IF hFile = -1 THEN
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL OR %FILE_FLAG_WRITE_THROUGH
    ELSE
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL
    END IF

    hFile = CreateFile(zFilName, AccessIs, ShareIs, BYVAL 0, %OPEN_ALWAYS, FlagAndAttribute, BYVAL 0)

    IF hFile = CLNG(%INVALID_HANDLE_VALUE) THEN    ' -1 Fail to create the file
       FUNCTION = GetLastError               ' Set the error code
       hFile = 0                             ' Reset handle number
    END IF

END FUNCTION

FUNCTION zsFileSize(zFileName AS ASCIIZ) AS QUAD
    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
    hFind = FindFirstFile(zFileName, fd)
    IF hFind <> CLNG(%INVALID_HANDLE_VALUE) THEN
       FUNCTION = (fd.nFileSizeHigh * (%MAXDWORD + 1)) + fd.nFileSizeLow
       CALL FindClose(hFind)
    END IF
END FUNCTION

' Dito GET
FUNCTION zsFGet (BYVAL hFile AS LONG, StringBuf AS STRING) AS LONG
    IF hFile THEN
       LOCAL LenBuf, ByttesReaded AS LONG
       LenBuf = LEN(StringBuf)
       IF LenBuf THEN
          IF ReadFile(hFile, BYVAL STRPTR(StringBuf), LenBuf, ByttesReaded, BYVAL 0) = 0 THEN
             FUNCTION = GetLastError
          END IF
       END IF
    END IF
END FUNCTION

' Dito CLOSE
SUB zsFClose (hFile AS LONG)
    IF hFile THEN CALL CloseHandle(hFile)
    hFile = 0
END SUB

' Delete a file or group of files.
FUNCTION zsKillFile(BYVAL sFullName AS STRING) AS LONG
    LOCAL szName AS ASCIIZ * %MAX_PATH, sPath AS STRING
    IF LEN(sFullName) THEN
       sPath = PATHNAME$(PATH, sFullName)
       ToKill$ = DIR$(sFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
       DO WHILE LEN(ToKill$)
          szName = sPath + ToKill$
          CALL SetFileAttributes(szName, %FILE_ATTRIBUTE_NORMAL)
          IF DeleteFile(szName) = 0 THEN FUNCTION = GetLastError: EXIT DO
          ToKill$ = DIR$
       LOOP
    END IF
END FUNCTION

FUNCTION ResolveLnk(zFileName AS ASCIIZ) AS STRING
    IF ISFILE(zFileName) THEN
       LOCAl K, So, hFile, nBufferSize AS LONG, sStringToFind, sBuffer AS STRING
       nBufferSize = zsFileSize(zFileName)
       IF nBufferSize THEN
          IF zsFOpen(zFileName, 0, 2, hFile) = 0 THEN
             sBuffer = STRING$(nBufferSize, 0)
             CALL zsFGet(hFile, sBuffer)
             CALL zsFClose(hFile)
             sBuffer = LCASE$(sBuffer)
             IF LEN(sBuffer) THEN
                sStringToFind = ".cpl,.exe,.dll"
                FOR K = 1 TO ParseCount(sStringToFind)
                   So = INSTR(sBuffer, UCODE$(PARSE$(sStringToFind, K)))
                   IF So THEN
                      sBuffer = LEFT$(sBuffer, So + 8)
                      So = INSTR(-1, sBuffer, UCODE$(":\"))
                      IF So THEN
                         FUNCTION = ACODE$(MID$(sBuffer, So - 2))
                         EXIT FOR
                      END IF
                   END IF
                NEXT
             END IF
          END IF
       END IF
    END IF
END FUNCTION

FUNCTION zsFolderGet(CSIDL AS DWORD) AS STRING
    LOCAL pItemIdList AS ITEMIDLIST POINTER
    LOCAL zBuffer     AS ASCIIZ * %MAX_PATH
    IF SHGetSpecialFolderLocation(0&, CSIDL, pItemIdList) = 0 THEN
       IF SHGetPathFromIDList(pItemIdList, zBuffer) THEN
          IF ASC(zBuffer, -1) <> 92 THEN zBuffer = zBuffer + "\"
          FUNCTION = zBuffer
       END IF
       CALL CoTaskMemFree(BYVAL pItemIdList)
    END IF
END FUNCTION

FUNCTION zsARGB(BYVAL A AS BYTE, BYVAL R AS BYTE, BYVAL G AS BYTE, BYVAL B AS BYTE) AS LONG
    DIM bytestruct AS COLORBYTES
    DIM result AS COLORLONG
    bytestruct.A = A
    bytestruct.R = R
    bytestruct.G = G
    bytestruct.B = B
    LSET result = bytestruct
    FUNCTION = result.longval
END FUNCTION

FUNCTION GetToolBarSize (w AS LONG, h AS LONG) AS LONG
    LOCAL hWnd AS LONG, rw AS RECT
    hWnd = FindWindow("Shell_TrayWnd", BYVAL 0&)
    IF hWnd THEN
       CALL GetWindowRect(hWnd, rw)
       w = rw.nRight - rw.nLeft
       h = rw.nBottom - rw.nTop
       IF rw.nTop > h THEN FUNCTION = h
    END IF
END FUNCTION

SUB ShowDesktopIcons(BYVAL bVisible AS LONG)
    CALL ShowWindow(GetWindow(FindWindow("Progman", "Program Manager"), %GW_CHILD), IIF(bVisible, %SW_SHOW, %SW_HIDE))
END SUB

'SUB EnableDesktop(BYVAL bEnable AS LONG)
'    CALL EnableWindow(GetWindow(FindWindow("Progman", "Program Manager"), %GW_CHILD), bEnable)
'END SUB

' Retrieve the name of a special CSIDL_ITEM
FUNCTION ShortCutDisplayName(CSIDL AS DWORD) AS STRING
    LOCAL pidl AS DWORD, sfi AS SHFILEINFO
    IF SHGetSpecialFolderLocation(0, CSIDL, pidl) = 0 THEN
       IF SHGetFileInfo(BYVAL pidl, 0, sfi, SIZEOF(sfi), %SHGFI_PIDL OR %SHGFI_DISPLAYNAME) THEN
          FUNCTION = sfi.szDisplayName
       END IF
       CALL CoTaskMemFree(BYVAL pidl)
    END IF
END FUNCTION

%CSIDL_DESKTOP                   = &H0000& '// <desktop>
%CSIDL_INTERNET                  = &H0001& ' Internet Explorer (icon on desktop)
%CSIDL_PROGRAMS                  = &H0002& ' Start Menu\Programs
%CSIDL_CONTROLS                  = &H0003& ' My Computer\Control Panel
%CSIDL_PRINTERS                  = &H0004& ' My Computer\Printers
%CSIDL_PERSONAL                  = &H0005& '// My Documents
%CSIDL_FAVORITES                 = &H0006& ' <user name>\Favorites
%CSIDL_STARTUP                   = &H0007& ' Start Menu\Programs\Startup
%CSIDL_RECENT                    = &H0008& ' <user name>\Recent
%CSIDL_SENDTO                    = &H0009& ' <user name>\SendTo
%CSIDL_BITBUCKET                 = &H000a& '// <desktop>\Recycle Bin
%CSIDL_STARTMENU                 = &H000b& ' <user name>\Start Menu
%CSIDL_MYMUSIC                   = &H000d& '// "My Music" folder
%CSIDL_MYVIDEO                   = &H000e& '// "My Videos" folder
%CSIDL_DESKTOPDIRECTORY          = &H0010& ' <user name>\Desktop
%CSIDL_DRIVES                    = &H0011& '// My Computer
%CSIDL_NETWORK                   = &H0012& '// Network Neighborhood
%CSIDL_NETHOOD                   = &H0013& ' <user name>\nethood
%CSIDL_FONTS                     = &H0014& ' windows\fonts
%CSIDL_TEMPLATES                 = &H0015&
%CSIDL_COMMON_STARTMENU          = &H0016& ' All Users\Start Menu
%CSIDL_COMMON_PROGRAMS           = &H0017& ' All Users\Programs
%CSIDL_COMMON_STARTUP            = &H0018& ' All Users\Startup
%CSIDL_COMMON_DESKTOPDIRECTORY   = &H0019& ' All Users\Desktop
%CSIDL_APPDATA                   = &H001a& ' <user name>\Application Data
%CSIDL_PRINTHOOD                 = &H001b& ' <user name>\PrintHood

FUNCTION ResolveShortcutName(zLnk AS ASCIIZ) AS STRING
    LOCAL sUseIcon AS STRING
    IF LEN(zLnk) THEN
       IF zLnk = ShortCutDisplayName(%CSIDL_BITBUCKET) THEN sUseIcon = "RecycleBin.png":             GOTO ExitLnk
       IF zLnk = ShortCutDisplayName(%CSIDL_DRIVES)    THEN sUseIcon = "MyComputer.png":             GOTO ExitLnk
       IF zLnk = ShortCutDisplayName(%CSIDL_NETWORK)   THEN sUseIcon = "NetworkNeighborhood.png":    GOTO ExitLnk
       IF zLnk = ShortCutDisplayName(%CSIDL_PERSONAL)  THEN sUseIcon = "MyDocuments.png":            GOTO ExitLnk
       IF zLnk = ShortCutDisplayName(%CSIDL_MYVIDEO)   THEN sUseIcon = "MyVideo.png":                GOTO ExitLnk
       IF zLnk = ShortCutDisplayName(%CSIDL_MYMUSIC)   THEN sUseIcon = "MyMusic.png":                GOTO ExitLnk
       IF (GetFileAttributes(zsFolderGet(%CSIDL_DESKTOP) + zLnk) AND 16) THEN sUseIcon = "Folder.png": GOTO ExitLnk
    END IF
    EXIT FUNCTION

ExitLnk:
    FUNCTION = sUseIcon
END FUNCTION

' Changes the character being used as delimiter to read in a sequential text file.
FUNCTION zsSetBufinChar (BYVAL Char$) STATIC AS STRING
    IF LEN(Char$) THEN UserChar$ = Char$
    IF LEN(UserChar$) THEN
       FUNCTION = UserChar$
    ELSE
       FUNCTION = CHR$(13)
    END IF
END FUNCTION

' Dito LOF
FUNCTION zsFlof (BYVAL hFile AS LONG) AS LONG
    IF GetFileType(hFile) = %FILE_TYPE_DISK THEN
       LOCAL fSize AS LONG
       fSize = GetFileSize(hFile, BYVAL 0)
       IF fSize > -1 THEN FUNCTION = fSize
    END IF
END FUNCTION

FUNCTION zsFPut (BYVAL hFile AS LONG, BYVAL Buf$) AS LONG
    LOCAL LenBuf, ByttesWritten AS LONG
    IF hFile THEN
       LenBuf = LEN(Buf$)
       IF LenBuf THEN
          IF WriteFile(hFile, BYVAL STRPTR(Buf$), LenBuf, ByttesWritten, BYVAL 0) = 0 THEN
             FUNCTION = GetLastError()
          END IF
       END IF
    END IF
END FUNCTION

' Dito SEEK
FUNCTION zsFSeek (BYVAL hFile AS LONG, BYVAL PosByte AS LONG) AS LONG
    IF SetFilePointer(hFile, PosByte, BYVAL 0, %FILE_BEGIN) < 0 THEN
       FUNCTION = GetLastError
    END IF
END FUNCTION

' GET at a specific offset
FUNCTION zsFGetAt (BYVAL hFile AS LONG, BYVAL nPosByte AS LONG, Buf$) AS LONG
    LOCAL nErrCode AS LONG
    nErrCode = zsFSeek(hFile, nPosByte)
    IF nErrCode = 0 THEN nErrCode = zsFGet(hFile, Buf$)
    FUNCTION = nErrCode
END FUNCTION

FUNCTION zsOTBpath(BYVAL sBF AS STRING, BYVAL sExePath AS STRING) AS STRING
    REPLACE "@PATH@" WITH sExePath IN sBF
    FUNCTION = sBF
END FUNCTION

FUNCTION zsPathOTB( BYVAL sExePath AS STRING, BYVAL sBF AS STRING) AS STRING
    REPLACE sExePath WITH "@PATH@" IN sBF
    FUNCTION = sBF
END FUNCTION

' Enhanced sequential LINEINPUT
FUNCTION zsBufin (zFileName AS ASCIIZ, nDone AS LONG) STATIC AS STRING
    DIM sCr AS STRING, sBuffer AS STRING
    DIM hFile AS LONG, nLocation AS LONG, nBufSize AS LONG, nBufPos AS LONG, nErrCode AS LONG, nRemaining AS LONG
    DIM nCr AS LONG, nSlop AS LONG, nReading AS LONG, nLenCr AS LONG, nSizeFile AS LONG, nSaveCr AS LONG
    IF LEN(zFileName) THEN
       IF NOT nReading THEN
          sCr = zsSetBufinChar("")          ' added for spec char
          nReading = -1: nDone = 0
          IF ASC(sCr) = 13 THEN             ' added for spec char
             nLenCr = 0: sCr = CHR$(13)
          ELSE                              ' added for spec char
             nLenCr = LEN(sCr)              ' added for spec char
          END IF                            ' added for spec char
          nCr = 0: nLocation = 0
          IF NOT ISFILE(zFileName) THEN GOTO BufEnd  ' Nothing to do
          nErrCode = zsFOpen(zFileName, 0, 2, hFile)
          IF nErrCode THEN
             nDone = nErrCode: nReading = 0
             EXIT FUNCTION
          END IF
          nRemaining = zsFlof(hFile)                  ' Bytes count to be read
          nSizeFile = nRemaining                     ' Remember this
          IF nRemaining = 0 GOTO BufEnd              ' Nothing to read
          nBufSize = 16384
          sBuffer = SPACE$(nBufSize)
       END IF
       DO WHILE nRemaining                           ' While more in the file
          IF nCr = 0 THEN                            ' If no return was found
             IF nRemaining < nBufSize THEN           ' read only what remains.
                nBufSize = nRemaining                ' Resize the buffer.
                IF nBufSize < 1 THEN EXIT DO         ' Possible only if EOF 26.
                sBuffer = SPACE$(nBufSize)
             END IF
             nErrCode = zsFGetAt(hFile, nLocation, sBuffer) ' Read a bloc.
             nLocation = nLocation + nBufSize        ' Here we are.
             nBufPos = 1                             ' Start at the beginning
          END IF                                     ' of that bloc.
          DO                                         ' Walk through buffer.
             nCr = INSTR(nBufPos, sBuffer, sCr)      ' Look for a Return.
             IF nLenCr = 0 THEN                      ' Do this to read files with
                nLenCr = 1                           ' or without LF after CR.
                IF ASC(sBuffer, nCr + 1) = 10 THEN nLenCr = 2
             END IF
             IF nCr THEN                             ' We found one.
                nSaveCr = nCr                        ' Save where
                FUNCTION = MID$(sBuffer, nBufPos, nCr - nBufPos)
                nBufPos = nCr + nLenCr               ' In case of LF skip it
                EXIT FUNCTION                        ' all done for now.
             ELSE                                    ' Back up in the file.
              ' If we reached the end of file and no nCr
              ' was found, return what remains in the string.
                IF nLocation >= nSizeFile THEN
                 ' Assign function and trap ^Z
                   FUNCTION = RTRIM$(MID$(sBuffer, nSaveCr + nLenCr), CHR$(26))
                   nRemaining = nBufSize
                   EXIT DO
                END IF
              ' 05-06-1998 () were missing on each side of (nLenCr - 1)
                nSlop = nBufSize - nSaveCr - (nLenCr - 1) ' Calc buffer excess.
                nRemaining = nRemaining + nSlop           ' Calc file excess.
                nLocation = nLocation - nSlop
             END IF
          LOOP WHILE nCr                                 ' While more in buffer.
          nRemaining = nRemaining - nBufSize
          nSaveCr = 0
       LOOP
    END IF

BufEnd:
    nReading = 0: nDone = -1: CALL zsFClose(hFile)
END FUNCTION

'// Computes location and size to stretch a bitmap preserving its aspect.
SUB zsComputeAspect (BYVAL xPicSize AS LONG, BYVAL yPicSize AS LONG, BYVAL xCell AS LONG, BYVAL yCell AS LONG, BYREF xPos AS LONG, BYREF yPos AS LONG, BYREF xSize AS LONG, BYREF ySize AS LONG)
    LOCAL scale AS SINGLE
    IF xPicSize THEN scale = xCell / xPicSize
    xSize = xPicSize * scale: ySize = yPicSize * scale
    IF ySize < yCell THEN
       IF yPicSize THEN scale = yCell / yPicSize
       xSize = xPicSize * scale: ySize = yPicSize * scale
    END IF
    xPos = (xCell - xSize) \ 2: yPos = (yCell - ySize) \ 2
END SUB

FUNCTION zsFitToSize(zImageSrce AS ASCIIZ, BYVAL nW AS LONG, BYVAL nH AS LONG, zImageDest AS ASCIIZ) AS LONG
    LOCAL hIC, hDC, hBmp, graphics, nRet, xP, yP, xS, yS, Img, ImgW, ImgH, ImgAttr AS LONG

    hIC = zsDisplayDC()

    Img = zLoadImageFromFile(zImageSrce, imgW, imgH, 0)
    CALL zsComputeAspect(ImgW, ImgH, nW, nH, xP, yP, xS, yS)

    hDC = CreateCompatibleDC(hIC)
    hBmp = ZI_CreateDIBSection(hIC, nW, nH, 32)
    CALL SelectObject(hDC, hBmp)

    IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
       CALL GdipSetInterpolationMode(graphics, 2)
       IF GdipDrawImageRectRectI(graphics, Img, xP, yP, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, ImgAttr) = 0 THEN nRet = -1
       CALL GdipDeleteGraphics(graphics)
    END IF
    CALL zsDisposeImage(Img)
    
    IF nRet THEN
       IF ZI_SaveBitmapToFile(zImageDest, hBmp, 0) THEN nRet = 0
    END IF
    
    CALL DeleteDC(hDC)
    CALL DeleteObject(hBmp)
    CALL DeleteDC(hIC)

    FUNCTION = nRet
END FUNCTION

DECLARE FUNCTION SHUpdateRecycleBinIcon LIB "SHELL32.DLL" ALIAS "SHUpdateRecycleBinIcon" () AS LONG
FUNCTION SHGetRecycleBinCount() AS QUAD
   DIM SHQBI AS SHQUERYRBINFO

   SHQBI.cbSize = SIZEOF(SHQUERYRBINFO)
   CALL SHQueryRecycleBin("", SHQBI)

   FUNCTION = SHQBI.i64NumItems
   
END FUNCTION

